#!/usr/bin/perl -w

use strict;      # force definations for all vars an subroutines
use warnings;    # force check of unset variables in expressions
use diagnostics; # give var/code line number on faults

use File::Basename; # for basename(),
use Cwd qw(abs_path); # for abs_path(),
use POSIX qw(strftime); # for strftime(),
use Time::HiRes qw(gettimeofday usleep); # for gettimeofday(), usleep(), ualarm, tv_interval,
use Date::Parse; # for str2time(),
use Text::Iconv;
use MIME::Base64 qw(decode_base64 encode_base64); # for decode_base64(), encode_base64(),
use MIME::QuotedPrint; # for decode_qp(),
use Digest::MD5 qw(md5 md5_hex md5_base64); # for md5(), md5_hex(), md5_base64(),

my $rootpath=dirname(abs_path($0));
my $conffile=dirname(dirname($rootpath)).'/etc/smtpdfilter/smtpdfilter.conf';
my $basename=basename($0);



if (!defined(&printr)) {
require('/home/user/mydocs/system/texts/postfix-tools/smtpdfilter-perl-content-filter/usr/lib/smtpdfilter/smtpdutils.pl');
}



if ($0 eq '/home/user/mydocs/system/texts/postfix-tools/smtpdfilter-perl-content-filter/usr/lib/smtpdfilter/message-parse.pl') {
	if ($#ARGV+1<=0) {
		print("Usage: $0 </path/to/message.eml>\n");
		exit(1);
	}
	if (!open(FILE,$ARGV[0])) {
		print("$0: Unable to open file".$ARGV[0]."\n");
		exit(2);
	}
	my @DATA=<FILE>;
	close(FILE);
	
	my (%CONT, %HEADERS, $conttext, $conthtml, %ATTACH);
	%HEADERS=&message_content_headers(join('',@DATA));
	%CONT=&message_content_parse(join('',@DATA));
	
	my ($k1, $k2, $k3, $k4, $k5);
	foreach $k1 (sort(keys(%CONT))) {
		if (ref($CONT{$k1}) eq 'HASH') {
			#print("\$CONT{$k1}---HASH=".join('|',sort(keys(%CONT)))."\n");
			
			foreach $k2 (sort(keys(%{$CONT{$k1}}))) {
				if (ref(${$CONT{$k1}}{$k2}) eq 'HASH') {
					#print("\$CONT{$k1}{$k2}---HASH:keys===>".join(',',sort(keys(%{$CONT{$k1}})))."\n");
					
					foreach $k3 (sort(keys(%{${$CONT{$k1}}{$k2}}))) {
						if (ref(${${$CONT{$k1}}{$k2}}{$k3}) eq 'HASH') {
							#print("\$CONT{$k1}{$k2}{$k3}---HASH:keys===>".join(',',sort(keys(%{${$CONT{$k1}}{$k2}})))."\n");
							
							foreach $k4 (sort(keys(%{${${$CONT{$k1}}{$k2}}{$k3}}))) {
								if (ref(${${${$CONT{$k1}}{$k2}}{$k3}}{$k4}) eq 'HASH') {
									#print("\$CONT{$k1}{$k2}{$k3}{$k4}---HASH:keys===>".join(',',sort(keys(%{${${$CONT{$k1}}{$k2}}{$k3}})))."\n");
									
								} else {
									#print("\$CONT{$k1}{$k2}{$k3}{$k4}=".${${${$CONT{$k1}}{$k2}}{$k3}}{$k4}."\n");
								}
							}
							
						} else {
							#print("\$CONT{$k1}{$k2}{$k3}=".${${$CONT{$k1}}{$k2}}{$k3}."\n");
						}
					}
					
					
				} else {
					#print("\$CONT{$k1}{$k2}=".${$CONT{$k1}}{$k2}."\n");
				}
			}
			
			
		} else {
			#print("\$CONT{$k1}=".$CONT{$k1}."\n");
		}
	}
	$conttext=&message_parsed_bodytext(\%CONT);
	$conthtml=&message_parsed_bodyhtml(\%CONT);
	%ATTACH  =&message_parsed_files   (\%CONT);
	print("===== HEADERS ====================================\n");
	printr(\%HEADERS);
	print("==================================================\n");
	print("conttext=|$conttext|\n");
	print("==================================================\n");
	print("conthtml=|$conthtml|\n");
	print("===== ATTACH =====================================\n");
	printr(\%ATTACH);
	print("==================================================\n");
	#my $pdf=decode_base64($ATTACH{'wyciag-2013-02-28.pdf'});
	#if (open(FILE,">/home/user/tmp/ffnet/wyciag-2013-02-28.pdf")) { print(FILE $pdf); close(FILE); }
}



sub strtolower {
	my ($string)=@_;
	# @_ = ARGS call function
	#my ();
	
	$string=~tr/[A-Z]/[a-z]/;
	return $string;
}



##########################################################################
# sub myiconv($content, $fromcode, $tocode)
# global:  -----
# @param   string \$content - reference to content
# @param   string $fromcode
# @param   string $tocode
# @return  void
# # TODO: FIXME: NOTICE(2008/07/19): cannot set_attr transliterate
#            A    C    E    L    N    O    S    Z    Z
# UTF-8:  C484 C486 C498 C581 C583 C393 C59A C5B9 C5BB = ACELNOSZZ
# UTF-8:  C485 C487 C499 C582 C584 C3B3 C59B C5BA C5BC = acelnoszz
# ISO02:    A1   C6   CA   A3   D1   D3   A6   AC   AF = ACELNOSZZ
# ISO02:    B1   E6   EA   B3   F1   F3   B6   BC   BF = acelnoszz
# CP1250:   A5   C6   CA   A3   D1   D3   8C   8F   AF = ACELNOSZZ
# CP1250:   B9   E6   EA   B3   F1   F3   9C   9F   BF = acelnoszz
# IBM852:   A4   8F   A8   9D   E3   E0   97   8D   BD = ACELNOSZZ
# IBM852:   A5   86   A9   88   E4   A2   98   AB   BE = acelnoszz
sub myiconv {
	my $content=\$_[0]; my $fromcode=$_[1]; my $tocode=$_[2];
	# @_ = ARGS call function
	my ($contdest, $iconv);
	
	$fromcode=lc($fromcode); $tocode=lc($tocode);
	if ($fromcode eq 'utf8' || $fromcode eq 'utf08') { $fromcode='utf-8'; } # to avoid mistakes
	if ($tocode   eq 'utf8' || $fromcode eq 'utf08') { $tocode='utf-8';   } # to avoid mistakes
	if ($fromcode eq 'iso 8859-2') { $fromcode='iso-8859-2'; } # to avoid mistakes
	if ($tocode   eq 'iso 8859-2') { $tocode='iso-8859-2';   } # to avoid mistakes
	if ($fromcode eq 'iso88592') { $fromcode='iso-8859-2'; } # to avoid mistakes
	if ($tocode   eq 'iso88592') { $tocode='iso-8859-2';   } # to avoid mistakes
	if ($fromcode eq 'windows-1250' || $fromcode eq 'win-1250') { $fromcode='cp1250'; }
	$contdest=${$content};
	# 2010/11/03: skip errors
	if ($fromcode eq 'utf-8') {
		if ($tocode eq 'iso-8859-2') {
			# utf-8 => iso-8859-2 (upper case)
			$contdest=~s/\x{C4}\x{84}/\x{A1}/g; $contdest=~s/\x{C4}\x{86}/\x{C6}/g; $contdest=~s/\x{C4}\x{98}/\x{CA}/g;
			$contdest=~s/\x{C5}\x{81}/\x{A3}/g; $contdest=~s/\x{C5}\x{83}/\x{D1}/g; $contdest=~s/\x{C3}\x{93}/\x{D3}/g;
			$contdest=~s/\x{C5}\x{9A}/\x{A6}/g; $contdest=~s/\x{C5}\x{B9}/\x{AC}/g; $contdest=~s/\x{C5}\x{BB}/\x{AF}/g;
			# utf-8 => iso-8859-2 (lower case)
			$contdest=~s/\x{C4}\x{85}/\x{B1}/g; $contdest=~s/\x{C4}\x{87}/\x{E6}/g; $contdest=~s/\x{C4}\x{99}/\x{EA}/g;
			$contdest=~s/\x{C5}\x{82}/\x{B3}/g; $contdest=~s/\x{C5}\x{84}/\x{F1}/g; $contdest=~s/\x{C3}\x{B3}/\x{F3}/g;
			$contdest=~s/\x{C5}\x{9B}/\x{B6}/g; $contdest=~s/\x{C5}\x{BA}/\x{BC}/g; $contdest=~s/\x{C5}\x{BC}/\x{BF}/g;
			
		} elsif ($tocode eq 'cp1250') {
			# utf-8 => cp1250 (upper case)
			$contdest=~s/\x{C4}\x{84}/\x{A5}/g; $contdest=~s/\x{C4}\x{86}/\x{C6}/g; $contdest=~s/\x{C4}\x{98}/\x{CA}/g;
			$contdest=~s/\x{C5}\x{81}/\x{A3}/g; $contdest=~s/\x{C5}\x{83}/\x{D1}/g; $contdest=~s/\x{C3}\x{93}/\x{D3}/g;
			$contdest=~s/\x{C5}\x{9A}/\x{8C}/g; $contdest=~s/\x{C5}\x{B9}/\x{8F}/g; $contdest=~s/\x{C5}\x{BB}/\x{AF}/g;
			# utf-8 => cp1250 (lower case)
			$contdest=~s/\x{C4}\x{85}/\x{B9}/g; $contdest=~s/\x{C4}\x{87}/\x{E6}/g; $contdest=~s/\x{C4}\x{99}/\x{EA}/g;
			$contdest=~s/\x{C5}\x{82}/\x{B3}/g; $contdest=~s/\x{C5}\x{84}/\x{F1}/g; $contdest=~s/\x{C3}\x{B3}/\x{F3}/g;
			$contdest=~s/\x{C5}\x{9B}/\x{9C}/g; $contdest=~s/\x{C5}\x{BA}/\x{9F}/g; $contdest=~s/\x{C5}\x{BC}/\x{BF}/g;
			
		}
	} elsif ($fromcode eq 'iso-8859-2') {
		if ($tocode eq 'utf-8') {
			# iso-8859-2 => utf-8 (lower case)
			$contdest=~s/\x{B1}/\x{C4}\x{85}/g; $contdest=~s/\x{E6}/\x{C4}\x{87}/g; $contdest=~s/\x{EA}/\x{C4}\x{99}/g;
			$contdest=~s/\x{B3}/\x{C5}\x{82}/g; $contdest=~s/\x{F1}/\x{C5}\x{84}/g; $contdest=~s/\x{F3}/\x{C3}\x{B3}/g;
			$contdest=~s/\x{B6}/\x{C5}\x{9B}/g; $contdest=~s/\x{BC}/\x{C5}\x{BA}/g; $contdest=~s/\x{BF}/\x{C5}\x{BC}/g;
			# iso-8859-2 => utf-8 (upper case)
			$contdest=~s/\x{A1}/\x{C4}\x{84}/g; $contdest=~s/\x{C6}/\x{C4}\x{86}/g; $contdest=~s/\x{CA}/\x{C4}\x{98}/g;
			$contdest=~s/\x{A3}/\x{C5}\x{81}/g; $contdest=~s/\x{D1}/\x{C5}\x{83}/g; $contdest=~s/\x{D3}/\x{C3}\x{93}/g;
			$contdest=~s/\x{A6}/\x{C5}\x{9A}/g; $contdest=~s/\x{AC}/\x{C5}\x{B9}/g; $contdest=~s/\x{AF}/\x{C5}\x{BB}/g;
			# 2011/05/27: STRANGE BUG: F3 => C3 (B3) => C3 (C5 82)
			$contdest=~s/\x{C3}\x{C5}\x{82}/\x{C3}\x{B3}/g;
			# 2011/05/28: STRANGE BUG: BC => C5 (BA) => C5 (C5 BA)
			$contdest=~s/\x{C5}\x{C5}\x{BA}/\x{C5}\x{BA}/g;
			
		} elsif ($tocode eq 'cp1250') {
			# iso-8859-2 => cp1250
			#$contdest=~tr/\x{A1}\x{A6}\x{AC}/\x{A5}\x{8C}\x{8F}/;
			#$contdest=~tr/\x{B1}\x{B6}\x{BC}/\x{B9}\x{9C}\x{9F}/;
			$contdest=~s/\x{A1}/\x{A5}/;
			$contdest=~s/\x{A6}/\x{8C}/;
			$contdest=~s/\x{AC}/\x{8F}/;
			$contdest=~s/\x{B1}/\x{B9}/;
			$contdest=~s/\x{B6}/\x{9C}/;
			$contdest=~s/\x{BC}/\x{9F}/;
		}
	} elsif ($fromcode eq 'cp1250') {
		if ($tocode eq 'utf-8') {
			# NOTICE(2009/06/13): lower case must be first, collision chars: B9
			# cp1250 => utf-8 (lower case)
			$contdest=~s/\x{B9}/\x{C4}\x{85}/g; $contdest=~s/\x{E6}/\x{C4}\x{87}/g; $contdest=~s/\x{EA}/\x{C4}\x{99}/g;
			$contdest=~s/\x{B3}/\x{C5}\x{82}/g; $contdest=~s/\x{F1}/\x{C5}\x{84}/g; $contdest=~s/\x{F3}/\x{C3}\x{B3}/g;
			$contdest=~s/\x{9C}/\x{C5}\x{9B}/g; $contdest=~s/\x{9F}/\x{C5}\x{BA}/g; $contdest=~s/\x{BF}/\x{C5}\x{BC}/g;
			# cp1250 => utf-8 (upper case)
			$contdest=~s/\x{A5}/\x{C4}\x{84}/g; $contdest=~s/\x{C6}/\x{C4}\x{86}/g; $contdest=~s/\x{CA}/\x{C4}\x{98}/g;
			$contdest=~s/\x{A3}/\x{C5}\x{81}/g; $contdest=~s/\x{D1}/\x{C5}\x{83}/g; $contdest=~s/\x{D3}/\x{C3}\x{93}/g;
			$contdest=~s/\x{8C}/\x{C5}\x{9A}/g; $contdest=~s/\x{8F}/\x{C5}\x{B9}/g; $contdest=~s/\x{AF}/\x{C5}\x{BB}/g;
			# 2011/05/27: STRANGE BUG: F3 => C3 (B3) => C3 (C5 82)
			$contdest=~s/\x{C3}\x{C5}\x{82}/\x{C3}\x{B3}/g;
			# 2011/05/28: STRANGE BUG: BC => C5 (BA) => C5 (C5 BA)
			$contdest=~s/\x{C5}\x{C5}\x{BA}/\x{C5}\x{BA}/g;
			
			# 2011/05/29: ä must be here to avoid bad conversion, E4 is too in char ibm852
			$contdest=~s/\x{E4}/\x{C3}\x{A4}/g;
			# 2011/05/29: ö must be here to avoid bad conversion
			$contdest=~s/\x{F6}/\x{C3}\x{B6}/g;
			
		} elsif ($tocode eq 'iso-8859-2') {
			# cp1250 => iso-8859-2
			#$contdest=~tr/\x{A5}\x{8C}\x{8F}/\x{A1}\x{A6}\x{AC}/;
			#$contdest=~tr/\x{B9}\x{9C}\x{9F}/\x{B1}\x{B6}\x{BC}/;
			$contdest=~s/\x{A5}/\x{A1}/;
			$contdest=~s/\x{8C}/\x{A6}/;
			$contdest=~s/\x{8F}/\x{AC}/;
			$contdest=~s/\x{B9}/\x{B1}/;
			$contdest=~s/\x{9C}/\x{B6}/;
			$contdest=~s/\x{9F}/\x{BC}/;
		}
	} elsif ($fromcode eq 'ibm852') {
		if ($tocode eq 'utf-8') {
			# NOTICE(2009/06/13): lower case must be first, collision chars: 98
			# ibm852 => utf-8 (lower case)
			$contdest=~s/\x{A5}/\x{C4}\x{85}/g; $contdest=~s/\x{86}/\x{C4}\x{87}/g; $contdest=~s/\x{A9}/\x{C4}\x{99}/g;
			$contdest=~s/\x{88}/\x{C5}\x{82}/g; $contdest=~s/\x{E4}/\x{C5}\x{84}/g; $contdest=~s/\x{A2}/\x{C3}\x{B3}/g;
			$contdest=~s/\x{98}/\x{C5}\x{9B}/g; $contdest=~s/\x{AB}/\x{C5}\x{BA}/g; $contdest=~s/\x{BE}/\x{C5}\x{BC}/g;
			# ibm852 => utf-8 (upper case)
			$contdest=~s/\x{A4}/\x{C4}\x{84}/g; $contdest=~s/\x{8F}/\x{C4}\x{86}/g; $contdest=~s/\x{A8}/\x{C4}\x{98}/g;
			$contdest=~s/\x{9D}/\x{C5}\x{81}/g; $contdest=~s/\x{E3}/\x{C5}\x{83}/g; $contdest=~s/\x{E0}/\x{C3}\x{93}/g;
			$contdest=~s/\x{97}/\x{C5}\x{9A}/g; $contdest=~s/\x{8D}/\x{C5}\x{B9}/g; $contdest=~s/\x{BD}/\x{C5}\x{BB}/g;
			
		}
	}
	#if (!defined($contdest)) {
	#	if (index('|iso-8859-1|cp1250|windows-1250|win-1250|iso-8859-2|iso88592|utf-8|ibm852|ibm850|', "|$fromcode|")>=0
	#		&& index('|iso-8859-1|cp1250|windows-1250|win-1250|iso-8859-2|iso88592|utf-8|ibm852|ibm850|', "|$tocode|")>=0) {
	#		$iconv=Text::Iconv->new($fromcode, $tocode);
	#		$contdest=$iconv->convert(${$content});
	#	}
	#}
	if (defined($contdest)) { ${$content}=$contdest; }
}



##########################################################################
# sub quote_decode($strhead, $totocode)
# global:  -----
# @param   string $strhead
# @return  string $strhead
sub quote_decode {
	my ($strhead, $totocode)=@_;
	if (!defined($totocode)) { $totocode='utf-8'; }
	# @_ = ARGS call function
	my ($lchead, $strtmp, $sp1);
	
	$lchead=lc($strhead);
	if (index($lchead,'=?iso-8859-2?q?')>=0) {
		$strhead=~s/=\?iso-8859-2\?q\?//gi;
		$strhead=~s/\?=//g;
		$strhead=decode_qp($strhead);
		if ($totocode ne 'iso-8859-2') { &myiconv($strhead, 'iso-8859-2', $totocode); }
	} elsif (index($lchead,'=?iso-8859-1?q?')>=0) {
		$strhead=~s/=\?iso-8859-1\?q\?//gi;
		$strhead=~s/\?=//g;
		$strhead=decode_qp($strhead);
		if ($totocode ne 'iso-8859-1') { &myiconv($strhead, 'iso-8859-1', $totocode); }
	} elsif (index($lchead,'=?utf-8?q?')>=0) {
		$strhead=~s/=\?utf-8\?q\?//gi;
		$strhead=~s/\?=//g;
		$strhead=decode_qp($strhead);
		if ($totocode ne 'utf-8') { &myiconv($strhead, 'utf-8', $totocode); }
	} elsif (index($lchead,'=?windows-1250?q?')>=0) {
		$strhead=~s/=\?windows-1250\?q\?//gi;
		$strhead=~s/\?=//g;
		$strhead=decode_qp($strhead);
		if ($totocode ne 'windows-1250' && $totocode ne 'cp1250') { &myiconv($strhead, 'windows-1250', $totocode); }
	} elsif (index($lchead,'=?cp1250?q?')>=0) {
		$strhead=~s/=\?cp1250\?q\?//gi;
		$strhead=~s/\?=//g;
		$strhead=decode_qp($strhead);
		if ($totocode ne 'windows-1250' && $totocode ne 'cp1250') { &myiconv($strhead, 'cp1250', $totocode); }
	} elsif (index($lchead,'=?iso-8859-2?b?')>=0) {
		$sp1=index($lchead,'=?iso-8859-2?b?');
		$strtmp=substr($strhead, $sp1+15);
		if (index($strtmp,'?=')>0) { $strtmp=substr($strtmp,0,index($strtmp,'?=')); }
		# NOTICE(2009/01/10): replace only base64 string (eliminate warning: Premature end of base64 data)
		$strtmp=decode_base64($strtmp);
		if ($totocode ne 'windows-1250' && $totocode ne 'cp1250') { &myiconv($strtmp, 'cp1250', $totocode); }
		if ($sp1>0) { $strhead=substr($strhead,0,$sp1) . $strtmp . substr($strhead,index($strhead,'?=')+2); }
		else { $strhead=$strtmp . substr($strhead,index($strhead,'?=')+2); }
	} elsif (index($lchead,'=?utf-8?b?')>=0) {
		$sp1=index($lchead,'=?utf-8?b?');
		$strtmp=substr($strhead, $sp1+10);
		if (index($strtmp,'?=')>0) { $strtmp=substr($strtmp,0,index($strtmp,'?=')); }
		# NOTICE(2009/01/10): replace only base64 string (eliminate warning: Premature end of base64 data)
		$strtmp=decode_base64($strtmp);
		if ($totocode ne 'windows-1250' && $totocode ne 'cp1250') { &myiconv($strtmp, 'cp1250', $totocode); }
		if ($sp1>0) { $strhead=substr($strhead,0,$sp1) . $strtmp . substr($strhead,index($strhead,'?=')+2); }
		else { $strhead=$strtmp . substr($strhead,index($strhead,'?=')+2); }
	} elsif (index($lchead,'=?cp1250?b?')>=0) {
		$sp1=index($lchead,'=?cp1250?b?');
		$strtmp=substr($strhead, $sp1+11);
		if (index($strtmp,'?=')>0) { $strtmp=substr($strtmp,0,index($strtmp,'?=')); }
		# NOTICE(2009/01/10): replace only base64 string (eliminate warning: Premature end of base64 data)
		$strtmp=decode_base64($strtmp);
		if ($totocode ne 'windows-1250' && $totocode ne 'cp1250') { &myiconv($strtmp, 'cp1250', $totocode); }
		if ($sp1>0) { $strhead=substr($strhead,0,$sp1) . $strtmp . substr($strhead,index($strhead,'?=')+2); }
		else { $strhead=$strtmp . substr($strhead,index($strhead,'?=')+2); }
	} elsif (index($lchead,'=?windows-1250?b?')>=0) {
		$sp1=index($lchead,'=?windows-1250?b?');
		$strtmp=substr($strhead, $sp1+17);
		if (index($strtmp,'?=')>0) { $strtmp=substr($strtmp,0,index($strtmp,'?=')); }
		# NOTICE(2009/01/10): replace only base64 string (eliminate warning: Premature end of base64 data)
		$strtmp=decode_base64($strtmp);
		if ($totocode ne 'windows-1250' && $totocode ne 'cp1250') { &myiconv($strtmp, 'cp1250', $totocode); }
		#if ($sp1>0) { $strhead=substr($strhead,0,$sp1) . $strtmp . substr($strhead,index($strhead,'?=')+2); }
		#else { $strhead=$strtmp . substr($strhead,index($strhead,'?=')+2); }
	}
	return $strhead;
}



##########################################################################
# sub entity_decode($content)
# global:  -----
# @param   string \$content - reference to content
# @return  void
sub entity_decode {
	my $content=\$_[0]; my $fromcode=$_[1];
	# @_ = ARGS call function
	#my ();
	
	if (lc($fromcode) eq 'iso-8859-1') {
		#${$content}=~s,\&#261;,ą,g; # A
		${$content}=~s,\&#261;,ą,g; # a
		#${$content}=~s,\&#261;,ą,g; # C
		${$content}=~s,\&#263;,ć,g; # c
		#${$content}=~s,\&#261;,ą,g; # E
		${$content}=~s,\&#281;,ę,g; # e
		#${$content}=~s,\&#261;,ą,g; # L
		${$content}=~s,\&#322;,ł,g; # l
		#${$content}=~s,\&#261;,ą,g; # N
		${$content}=~s,\&#324;,ń,g; # n
		#${$content}=~s,\&#261;,ą,g; # O
		${$content}=~s,\&#243;,ó,g; # o
		#${$content}=~s,\&#261;,ą,g; # S
		${$content}=~s,\&#347;,ś,g; # s
		#${$content}=~s,\&#261;,ą,g; # Z
		#${$content}=~s,\&#261;,ą,g; # z
		#${$content}=~s,\&#261;,ą,g; # Z
		${$content}=~s,\&#380;,ż,g; # z
		${$content}=~s,\&#8211;,-,g; # -
	}
	if (lc($fromcode) eq 'iso-8859-2') {
		
	}
	if (lc($fromcode) eq 'cp1250' || lc($fromcode) eq 'windows-1250') {
		
	}
	if (lc($fromcode) eq 'iso-8859-1') {
		
	}
	if (lc($fromcode) eq 'utf-8') {
		${$content}=~s,\&oacute;,ó,g; # ó
	}
}



##########################################################################
# sub header_line_decode($instring, $outcharset)
# global:  -----
# @param   string $instring
# @param   string $outcharset (default: utf-8)
# @return  string
sub header_line_decode {
	my ($instring, $outcharset)=@_;
	# @_ = ARGS call function
	my ($outstring, $sp1, $sp2, $sp3, $sp4, $spb, $spe, $partstring, $charset);
	if (!defined($outcharset)) { $outcharset='utf-8'; }
	
		$outstring=$instring; undef($instring);
		$sp1=index($outstring, '=?');
		$sp2=index($outstring, '?=');
		while ($sp1>=0 && $sp2>=0 && $sp2>$sp1) {
			$partstring=substr($outstring, $sp1, $sp2-$sp1+2);
			#print("partstring1=|$partstring|\n");
			$sp3=index($partstring, '=?');
			$sp4=index($partstring, '?', $sp3+2);
			if ($sp3>=0 && $sp4>=0) { $charset=substr($partstring, $sp3+2, $sp4-$sp3-2); }
			else                    { $charset=''; }
			#print("charset=$charset\n");
			#print("partstring1=|$partstring|\n");
			if (index($partstring,'?Q?')>=0) { $partstring=quote_decode($partstring); $partstring=~s,_, ,g; }
			if (index($partstring,'?Q?')>=0) { $partstring=~s,_, ,g; }
			if (length($charset)>0) { &myiconv($partstring, $charset, $outcharset); }
			#print("partstring2=|$partstring|\n");
			$spb=index($partstring, '?');
			if ($spb>=0) { $spb=index($partstring, '?', $spb+1); }
			if ($spb>=0) { $spb=index($partstring, '?', $spb+1); }
			if ($spb>=0) { $partstring=substr($partstring, $spb+1); }
			#print("partstring4=|$partstring|\n");
			$spe=index($partstring, '?=');
			if ($spe>=0) { $partstring=substr($partstring, 0, $spe); }
			#print("partstring4=|$partstring|\n");
			$outstring=substr($outstring, 0, $sp1).$partstring.substr($outstring, $sp2+2);
			if ($sp1<length($outstring)) { $sp1=index($outstring, '=?', $sp1+2); }
			else                         { last; }
			if ($sp2<length($outstring)) { $sp2=index($outstring, '?=', $sp2+2); }
			else                         { last; }
		}
	
	return $outstring;
}



##########################################################################
# sub message_header_readkey()
# global   -----
# @param   string $emlscont
# @param   string $keyname
# @param   int    $lowercase (default: 0)
# @return  string
sub message_header_readkey {
	my ($conttype, $keyname, $lowercase)=@_;
	# @_ = ARGS call function
	my ($keycont, $sp1, $sp2);
	if (!defined($lowercase)) { $lowercase=0; }
	
	$keycont='';
	#print(basename(__FILE__).":".__LINE__.":message_header_readkey(): keyname=|$keyname| lowercase=|$lowercase| conttype=|$conttype|\n");
	$sp1=index($conttype, $keyname);
	if ($sp1>=0) { $sp2=index($conttype, '=', $sp1); } else { $sp2=-1; }
	if (length($conttype)>0 && $sp1>0 && $sp2>0 && $sp2>$sp1) {
		$keycont=substr($conttype, $sp2+1);
		#print(basename(__FILE__).":".__LINE__.":message_header_readkey(): keycont=|$keycont|\n");
		
		$sp1=index($keycont, '"');
		if ($sp1>=0) { $sp2=index($keycont, '"', $sp1+1); } else { $sp2=-1; }
		if ($sp1>=0 && $sp2>=0 && $sp2>$sp1+1) {
			$keycont=substr($keycont, $sp1+1);
			#print(basename(__FILE__).":".__LINE__.":message_header_readkey(): sp1=$sp1 sp2=$sp2 keycont=|$keycont|\n");
			$sp2=index($keycont, '"');
			if ($sp2>0) { $keycont=substr($keycont, 0, $sp2); }
		}
		#print(basename(__FILE__).":".__LINE__.":message_header_readkey(): keycont=|$keycont|\n");
		$sp1=index($keycont, ';');
		if ($sp1>0) { $keycont=substr($keycont, 0, $sp1); }
		#print(basename(__FILE__).":".__LINE__.":message_header_readkey(): keycont=|$keycont|\n");
	}
	#print(basename(__FILE__).":".__LINE__.":message_header_readkey(): keycont=|$keycont|\n");
	if ($lowercase==1) { $keycont=lc($keycont); }
	return $keycont;
}



##########################################################################
# sub message_content_parse()
# global   -----
# @param   string $emlscont
# @return  array
sub message_content_parse {
	my ($emlscont)=@_;
	# @_ = ARGS call function
	my (%EMLSPARSED, %EMLSPACK, @EMLSCONT, $emlsheaders, $partline, %EMLSHEADERS);
	my ($boundary, @PARTCONT, $partcont, $key, $val, $emlsline, $boundline, $emlslows);
	
	%EMLSPARSED=();
	@EMLSCONT=split(/\x{0A}/, $emlscont);
	# because split do not add into list empty lines we must do this manually
	for ($key=0;$key<100;$key++) { if (ord(substr($emlscont,length($emlscont)-1-$key,1)) eq 0x0A) { push(@EMLSCONT, ''); } else { last; } }
	undef($emlscont);
	#printr(\@EMLSCONT);
	
	$emlsheaders='';
	while ($#EMLSCONT+1>0) {
		$partline=shift(@EMLSCONT);
		$partline=~s,[\r\n]*$,,g;
		if (length($partline)==0) { last; }
		$emlsheaders=$emlsheaders.$partline."\n";
	}
	%EMLSHEADERS=&message_content_headers($emlsheaders); undef($emlsheaders);
	#printr(\%EMLSHEADERS);
	
	if (defined($EMLSHEADERS{'Content-Type:boundary'})) {
		
		$boundary=lc($EMLSHEADERS{'Content-Type:boundary'});
		#printr(\@EMLSCONT);
		$boundline='';
		@PARTCONT=();
		foreach $key (0..$#EMLSCONT) { $emlsline=$EMLSCONT[$key];
			$emlsline=~s,[\r\n]*$,,g; #$emlsline=rtrim($emlsline, "\r\n");
			$emlslows=lc($emlsline);
			#print(basename(__FILE__).":".__LINE__.":message_content_parse(): foreach(emlsline) === emlslows($boundary)=|$emlslows|\n");
			if ($emlslows eq '--'.$boundary || $emlslows eq '--'.$boundary.'--') {
				#if ($emlslows=='--'.$boundary     ) { print(basename(__FILE__).":".__LINE__.":message_content_parse(): if (line==boundary  ): START: emlslows=|$emlslows|\n"); }
				#if ($emlslows=='--'.$boundary.'--') { print(basename(__FILE__).":".__LINE__.":message_content_parse(): if (line==boundary--): END:   emlslows=|$emlslows|\n"); }
				if ($#PARTCONT+1>0) { # if (count($PARTCONT)>0)
					
					# join content
					$partcont=join("\x{0A}", @PARTCONT); undef(@PARTCONT);
					#print(basename(__FILE__).":".__LINE__.":message_content_parse(): partcont=|$partcont|\n");
					
					%EMLSPACK=message_content_parse($partcont);
					#printr(\%EMLSPACK);
					my @KEYS=keys(%EMLSPARSED); my $count=$#KEYS+1; %{$EMLSPARSED{$count}}=%EMLSPACK; # array_push($EMLSPARSED, $EMLSPACK);
					
				}
				undef(@PARTCONT);
				@PARTCONT=();
				$boundline=$emlsline;
				
				if ($emlslows eq '--'.$boundary     ) { next; }
				if ($emlslows eq '--'.$boundary.'--') { last; }
			}
			if (length($boundline)>0) {
				$PARTCONT[$#PARTCONT+1]=$emlsline; # array_push($PARTCONT, $emlsline);
			}
		}
				if ($#PARTCONT+1>0) {
					
					# join content
					$partcont=join("\x{0A}", @PARTCONT); undef(@PARTCONT);
					#print(basename(__FILE__).":".__LINE__.":message_content_parse(): part=|$part|\n");
					
					%EMLSPACK=message_content_parse($partcont);
					#printr(\%EMLSPACK);
					my @KEYS=keys(%EMLSPARSED); my $count=$#KEYS+1; %{$EMLSPARSED{$count}}=%EMLSPACK; #array_push($EMLSPARSED, $EMLSPACK);
					
				}
				undef(@PARTCONT);
				@PARTCONT=();
		#printr(\%EMLSPARSED);
		
	} else {
		
		# join content NOTICE: @name because implode() do no append new line when element array is empty, we need do implode manually !!!
		#$emlscont=join("\x{0A}", @EMLSCONT);
		$emlscont=''; foreach $key (0..$#EMLSCONT) { $val=$EMLSCONT[$key]; $emlscont=$emlscont.$val."\n"; } undef(@EMLSCONT);
		#print(basename(__FILE__).":".__LINE__.":message_content_parse(): emlscont=|$emlscont|\n");
		if (defined($EMLSHEADERS{'Content-Transfer-Encoding'}) && $EMLSHEADERS{'Content-Transfer-Encoding'} eq 'quoted-printable') { $emlscont=decode_qp($emlscont); }
		if (defined($EMLSHEADERS{'Content-Transfer-Encoding'}) && $EMLSHEADERS{'Content-Transfer-Encoding'} eq 'base64') { $emlscont=decode_base64($emlscont); }
		if (defined($EMLSHEADERS{'Content-Type:charset'}) && length($EMLSHEADERS{'Content-Type:charset'})>0) { &entity_decode($emlscont, $EMLSHEADERS{'Content-Type:charset'}); &myiconv($emlscont, $EMLSHEADERS{'Content-Type:charset'}, 'utf-8'); }
		%EMLSPACK=(); %{$EMLSPACK{'HEAD'}}=%EMLSHEADERS, $EMLSPACK{'body'}=$emlscont; undef(%EMLSHEADERS); undef($emlscont);
		my @KEYS=keys(%EMLSPARSED); my $count=$#KEYS+1; %{$EMLSPARSED{$count}}=%EMLSPACK; #array_push($EMLSPARSED, $EMLSPACK);
		
	}
	return %EMLSPARSED;
}



##########################################################################
# sub message_content_headers()
# global   -----
# @param   string $strheaders
# @return  HASH
sub message_content_headers {
	my ($strheaders)=@_;
	# @_ = ARGS call function
	my (@HEADLST, %HEADERS, $prev, $recvind, $XVSind);
	my ($key, $val, $line, $firstchar, $sp1, $sp2);
	
	@HEADLST=split(/\x{0A}/, $strheaders);
	#printr(\@HEADLST);
	%HEADERS=();
	$prev='0';
	$recvind=0;
	$XVSind=0;
	
	foreach $key (0..$#HEADLST) { $line=$HEADLST[$key]; $line=~s,[\r\n]+$,,g;
		if (length($line)<=0) { last; }
		$firstchar=ord(substr($line, 0, 1));
		$sp1=index($line, ":");
		#print(basename(__FILE__).":".__LINE__.":message_content_headers(): length(\$line)=".length($line)." $firstchar|$line|\n");
		if ($firstchar==0x20 || $firstchar==0x08 || $firstchar==0x09) {
			$line=~'s/^[\s\t]+//';
			$val=$val.' '.$line;
			if ($key eq 'X-Virus-Scanned') { $HEADERS{'X-Virus-Scanned'}=$val; }
			if ($key eq 'Received')        { $HEADERS{'Received'}=$val; }
			$HEADERS{$prev}=$val;
		} elsif ($sp1>0) {
			$key=substr($line, 0, $sp1);
			if ($key eq 'Received') { $key=$key.$recvind; $recvind++; }
			if ($key eq 'X-Virus-Scanned') { $key=$key.$XVSind; $XVSind++; }
			$val=substr($line, $sp1+1);
			$val=~s/^[\s\t]+//; # $val=preg_replace('/^[\s\t]+/', '', $val);
			#print(basename(__FILE__).":".__LINE__.":message_content_headers(): $key=|$val|\n");
			$HEADERS{$key}=$val;
			$prev=$key;
		} else {
			
		}
	}
	
	# canonize headers keys
	foreach $key (keys(%HEADERS)) {
		if (lc($key) eq lc('Return-Path'))  { $HEADERS{'Return-Path'} =$HEADERS{$key}; }
		if (lc($key) eq lc('User-Agent'))   { $HEADERS{'User-Agent'}  =$HEADERS{$key}; }
		if (lc($key) eq lc('From'))         { $HEADERS{'From'}        =$HEADERS{$key}; }
		if (lc($key) eq lc('To'))           { $HEADERS{'To'}          =$HEADERS{$key}; }
		if (lc($key) eq lc('Subject'))      { $HEADERS{'Subject'}     =$HEADERS{$key}; }
		if (lc($key) eq lc('Date'))         { $HEADERS{'Date'}        =$HEADERS{$key}; }
		if (lc($key) eq lc('Message_ID'))   { $HEADERS{'Message-ID'}  =$HEADERS{$key}; }
		if (lc($key) eq lc('Message-ID'))   { $HEADERS{'Message-ID'}  =$HEADERS{$key}; }
		if (lc($key) eq lc('Content-Type')) { $HEADERS{'Content-Type'}=$HEADERS{$key}; }
		if (lc($key) eq lc('Content-Transfer-Encoding')) { $HEADERS{'Content-Transfer-Encoding'}=$HEADERS{$key}; }
		if (lc($key) eq lc('Content-Disposition')      ) { $HEADERS{'Content-Disposition'}      =$HEADERS{$key}; }
	}
	
	#printr(\%HEADERS);
	if (defined($HEADERS{'From'}) && length($HEADERS{'From'})>0) {
		$sp1=index($HEADERS{'From'},'<');
		$sp2=index($HEADERS{'From'},'>');
		if ($sp1>=0 && $sp2>=0 && $sp2>$sp1) { $HEADERS{'EmailFrom'}=substr($HEADERS{'From'}, $sp1+1, $sp2-$sp1-1); }
		else { $HEADERS{'EmailFrom'}=$HEADERS{'From'}; }
	}
	if (defined($HEADERS{'To'}) && length($HEADERS{'To'})>0) {
		$sp1=index($HEADERS{'To'},'<');
		$sp2=index($HEADERS{'To'},'>');
		if ($sp1>=0 && $sp2>=0 && $sp2>$sp1) { $HEADERS{'EmailTo'}=substr($HEADERS{'To'}, $sp1+1, $sp2-$sp1-1); }
		else { $HEADERS{'EmailTo'}=$HEADERS{'To'}; }
	}
	
	if (defined($HEADERS{'Content-Type'}) && length($HEADERS{'Content-Type'})>0) {
		$val=&message_header_readkey($HEADERS{'Content-Type'}, 'charset');
		if (length($val)>0) { $HEADERS{'Content-Type:charset'}=$val; }
	}
	if (defined($HEADERS{'Content-Type'}) && length($HEADERS{'Content-Type'})>0) {
		$val=&message_header_readkey($HEADERS{'Content-Type'}, 'name');
		if (length($val)>0) { $HEADERS{'Content-Type:name'}=$val; }
	}
	if (defined($HEADERS{'Content-Type'}) && length($HEADERS{'Content-Type'})>0) {
		$val=&message_header_readkey($HEADERS{'Content-Type'}, 'boundary');
		if (length($val)>0) { $HEADERS{'Content-Type:boundary'}=$val; }
	}
	if (defined($HEADERS{'Content-Disposition'}) && length($HEADERS{'Content-Disposition'})>0) {
		$val=&message_header_readkey($HEADERS{'Content-Disposition'}, 'filename');
		if (length($val)>0) { $HEADERS{'Content-Disposition:filename'}=$val; }
	}
	if  (defined($HEADERS{'Date'}) && length($HEADERS{'Date'})>0) { $HEADERS{'unixtime'}=str2time($HEADERS{'Date'}); }
	else { $HEADERS{'unixtime'}=0; }
	$HEADERS{'hrdate'}=strftime('%Y/%m/%d %H:%M:%S', localtime($HEADERS{'unixtime'}));
	$HEADERS{'strdate'}=$HEADERS{'hrdate'}; # history reason, TODO: remove in the future
	
	if (defined($HEADERS{'User-Agent'}) && length($HEADERS{'User-Agent'})>0) { $HEADERS{'User-Agent'}=&header_line_decode($HEADERS{'User-Agent'}); }
	if (defined($HEADERS{'From'})       && length($HEADERS{'From'})>0)       { $HEADERS{'From'}      =&header_line_decode($HEADERS{'From'}      ); }
	if (defined($HEADERS{'To'})         && length($HEADERS{'To'})>0)         { $HEADERS{'To'}        =&header_line_decode($HEADERS{'To'}        ); }
	if (defined($HEADERS{'Subject'})    && length($HEADERS{'Subject'})>0)    { $HEADERS{'Subject'}   =&header_line_decode($HEADERS{'Subject'}   ); }
	#printr(\%HEADERS);
	
	return %HEADERS;
}



##########################################################################
# sub message_parsed_bodytext()
# global   -----
# @param   HASH   \%PARSED
# @return  string
sub message_parsed_bodytext {
	my ($RPARSED)=@_;
	# @_ = ARGS call function
	my (%PARSED, $conttext, $key, $val); %PARSED=%{$RPARSED};
	
	$conttext='';
	foreach $key (sort(keys(%PARSED))) { $val=$PARSED{$key};
		if (defined($PARSED{$key}{'HEAD'}) && defined($PARSED{$key}{'HEAD'}{'Content-Type'}) && length($PARSED{$key}{'HEAD'}{'Content-Type'})>0 && index($PARSED{$key}{'HEAD'}{'Content-Type'},'text/plain')>=0) {
			$conttext=$PARSED{$key}{'body'};
			#print(basename(__FILE__).":".__LINE__.":message_parsed_bodytext():1a: conttext=|$conttext|<br />\n");
			if (length($conttext)>0) { last; }
		}
		if (defined($PARSED{$key}{'HEAD'}) && !defined($PARSED{$key}{'HEAD'}{'Content-Type'})) {
			$conttext=$PARSED{$key}{'body'};
			#print(basename(__FILE__).":".__LINE__.":message_parsed_bodytext():1b: conttext=|$conttext|<br />\n");
			if (length($conttext)>0) { last; }
		}
	}
	if (length($conttext)<=0) {
		foreach $key (sort(keys(%PARSED))) { $val=$PARSED{$key};
			if (!defined($PARSED{$key}{'HEAD'}) && !defined($PARSED{$key}{'body'})) {
				#printr(\$PARSED[$key]);
				$conttext=&message_parsed_bodytext($PARSED{$key});
				#print(basename(__FILE__).":".__LINE__.":message_parsed_bodytext():2: conttext=|$conttext|<br />\n");
				if (length($conttext)>0) { last; }
			}
		}
	}
	#print(basename(__FILE__).":".__LINE__.":message_parsed_bodytext(): return conttext=|$conttext|<br />\n");
	return $conttext;
}



##########################################################################
# sub message_parsed_bodyhtml()
# global   -----
# @param   HASH   \%PARSED
# @return  string
sub message_parsed_bodyhtml {
	my ($RPARSED)=@_;
	# @_ = ARGS call function
	my (%PARSED, $conthtml, $key, $val); %PARSED=%{$RPARSED};
	
	$conthtml='';
	foreach $key (sort(keys(%PARSED))) { $val=$PARSED{$key};
		if (defined($PARSED{$key}{'HEAD'}) && defined($PARSED{$key}{'HEAD'}{'Content-Type'}) && length($PARSED{$key}{'HEAD'}{'Content-Type'})>0 && index($PARSED{$key}{'HEAD'}{'Content-Type'},'text/html')>=0) {
			$conthtml=$PARSED{$key}{'body'};
			#print(basename(__FILE__).":".__LINE__.":message_parsed_bodytext():1a: conthtml=|$conthtml|<br />\n");
			if (length($conthtml)>0) { last; }
		}
	}
	if (length($conthtml)<=0) {
		foreach $key (sort(keys(%PARSED))) { $val=$PARSED{$key};
			if (!defined($PARSED{$key}{'HEAD'}) && !defined($PARSED{$key}{'body'})) {
				#printr(\$PARSED[$key]);
				$conthtml=&message_parsed_bodyhtml($PARSED{$key});
				#print(basename(__FILE__).":".__LINE__.":message_parsed_bodytext():2: conthtml=|$conthtml|<br />\n");
				if (length($conthtml)>0) { last; }
			}
		}
	}
	#print(basename(__FILE__).":".__LINE__.":message_parsed_bodytext(): return conthtml=|$conthtml|<br />\n");
	return $conthtml;
}



##########################################################################
# sub message_parsed_files()
# global   -----
# @param   HASH   \%PARSED
# @return  HASH
sub message_parsed_files {
	my ($RPARSED)=@_;
	# @_ = ARGS call function
	my (%PARSED, %ATTACH, %ATTARR, $key, $val, $filename); %PARSED=%{$RPARSED};
	
	%ATTACH=();
	foreach $key (sort(keys(%PARSED))) { $val=$PARSED{$key};
		if (defined($PARSED{$key}{'HEAD'}) && defined($PARSED{$key}{'HEAD'}{'Content-Disposition:filename'}) && length($PARSED{$key}{'HEAD'}{'Content-Disposition:filename'})>0) {
			#print(basename(__FILE__).":".__LINE__.":message_parsed_files():1: filename=".$PARSED{$key}{'HEAD'}{'Content-Disposition:filename'}."<br />\n");
			$filename=$PARSED{$key}{'HEAD'}{'Content-Disposition:filename'};
			$ATTACH{$filename}=$PARSED{$key}{'body'};
		}
	}
	#if (empty($conthtml)) {
		foreach $key (sort(keys(%PARSED))) { $val=$PARSED{$key};
			if (!defined($PARSED{$key}{'HEAD'}) && !defined($PARSED{$key}{'body'})) {
				#print(basename(__FILE__).":".__LINE__.":message_parsed_files():2: message_parsed_files(PARSED[key]):<br />\n");
				%ATTARR=&message_parsed_files($PARSED{$key});
				#%ATTACH=array_merge(%ATTACH, %ATTARR); # NOTICE: @name perl does not have array_merge, do it manually
				foreach $filename (sort(keys(%ATTARR))) { $ATTACH{$filename}=$ATTARR{$filename}; } undef(%ATTARR);
			}
		}
	#}
	#print(basename(__FILE__).":".__LINE__.":message_parsed_files():3: return:ATTACH:<br />\n");
	#printr(\%ATTACH);
	return %ATTACH;
}



1; # return status for include mode


