#!/usr/bin/perl -w

use strict;      # force definations for all vars an subroutines
use warnings;    # force check of unset variables in expressions
use diagnostics; # give var/code line number on faults

use File::Basename; # for basename(),



##########################################################################
# sub perl_content_filter($FHANDLE, \$retcntr, \$retmsgs, \%CPSMTPD, \%CPSOCKINFO, \%CPCONFIG, \%CPHEADERS)
# global   -----
# @param   handle $FHANDLE
# @param   int    \$retcntr    - reference int
# @param   string \$retmsgs    - reference string
# @param   HASH   \%CPSMTPD    - reference HASH
#          string $RCPSMTPD->{'HELO'}
#          string $RCPSMTPD->{'FROM'}
#          LIST   @{$RCPSMTPD->{'TO'}}
#          string $RCPSMTPD->{'DATA'}
# @param   HASH   \%CPSOCKINFO - reference HASH
#          string $RCPSOCKINFO->{'sockaddr'}
#          string $RCPSOCKINFO->{'sockhost'}
#          string $RCPSOCKINFO->{'sockport'}
#          string $RCPSOCKINFO->{'peeraddr'}
#          string $RCPSOCKINFO->{'peerhost'}
#          string $RCPSOCKINFO->{'peerport'}
# @param   HASH   \%CPCONFIG   - reference HASH
#          string $RCPCONFIG->{value}
# @param   HASH   \%CPHEADERS  - reference HASH
#          string $RCPHEADERS->{'From'}
#          string $RCPHEADERS->{'To'}
#          string $RCPHEADERS->{'Subject'}
#          string $RCPHEADERS->{'...'}
# @return  int    - # plugin $status==0  plugin returned status in references $retcntr+$retmsgs
# @return  int    - # plugin $status==-1 means DROP message
# @return  int    - # plugin $status==1  means ACCEPT message (messsage counter=0 and stop analyze message)
# @return  int    - # plugin $status==2  plugin modified content or headers
sub perl_content_filter {
	my ($FHANDLE, $Rretcntr, $Rretmsgs, $RCPSMTPD, $RCPSOCKINFO, $RCPCONFIG, $RCPHEADERS)=@_;
	my ($retval, $mailfrom, $hdrsfrom, @MAILTOTO, $hdrstoto);
	my (%TRANSPORT, %SMTPAUTH);
	my ($passwdmap, $transport, $line, $sp1);
	my ($todomain, $smtpdest, $smtpauth, $smtphost, $smtpuser, $smtppass, $smtpudom);
	
	$retval=0;
	${$Rretcntr}=0; ${$Rretmsgs}='';
	$mailfrom=$RCPSMTPD->{'FROM'};
	$hdrsfrom=$RCPHEADERS->{'From'};
	@MAILTOTO=@{$RCPSMTPD->{'TO'}};
	$hdrstoto=$RCPHEADERS->{'To'};
	
	$passwdmap='/etc/postfix/sasl_password_maps';
	$transport='/etc/postfix/transport';
	$passwdmap='/mnt/nfs/temp/sasl_password_maps';
	$transport='/mnt/nfs/temp/transport';
	if (open(TRANSP,$transport) && open(PASSWD,$passwdmap)) {
		%TRANSPORT=(); %SMTPAUTH=();
		
		while ($line=<TRANSP>) {
			$line=~s,^[\s\t]*,,g;
			$line=~s,[\s\t\r\n]*$,,g;
			if (length($line)<=0) { next; }
			if (substr($line,0,1) eq '#') { next; }
			#print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): line=|$line|\n");
			
			$todomain=$line;           $smtpdest=$line;
			$todomain=~s,[\s\t].*$,,g; $smtpdest=~s,^.*[\s\t],,g;
			#print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): destdomn=|$todomain| smtpdest=|$smtpdest|\n");
			
			$smtphost=$smtpdest;
			$sp1=index($smtphost, ':'); if ($sp1>=0) { $smtphost=substr($smtphost, $sp1+1); }
			$sp1=index($smtphost, ':'); if ($sp1>=0) { $smtphost=substr($smtphost, 0, $sp1); }
			$sp1=index($smtphost, '['); if ($sp1>=0) { $smtphost=substr($smtphost, $sp1+1); }
			$sp1=index($smtphost, ']'); if ($sp1>=0) { $smtphost=substr($smtphost, 0, $sp1); }
			print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): destdomn=|$todomain| ===> smtphost=|$smtphost|\n");
			$TRANSPORT{$todomain}=$smtphost;
		}
		
		while ($line=<PASSWD>) {
			$line=~s,[\s\t\r\n]*$,,g;
			#print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): line=|$line|\n");
			($smtpdest, $smtpauth)=split(/ /, $line);
			#print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): smtpdest=|$smtpdest| smtpauth=|$smtpauth|\n");
			
			$smtphost=$smtpdest;
			$sp1=index($smtphost, ':'); if ($sp1>=0) { $smtphost=substr($smtphost, 0, $sp1); }
			$sp1=index($smtphost, '['); if ($sp1>=0) { $smtphost=substr($smtphost,  $sp1+1); }
			$sp1=index($smtphost, ']'); if ($sp1>=0) { $smtphost=substr($smtphost, 0, $sp1); }
			#print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): smtphost=|$smtphost|\n");
			
			$smtpauth=~s,^[\s\t]*|[\s\t]*$,,g;
			($smtpuser, $smtppass)=split(/:/, $smtpauth);
			print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): smtphost=|$smtphost| ===> smtpuser=|$smtpuser| smtppass=|$smtppass|\n");
			$SMTPAUTH{$smtphost}=$smtpuser;
		}
		
		close(TRANSP);
		close(PASSWD);
		
		$todomain=$MAILTOTO[0];
		$sp1=index($todomain, '<'); if ($sp1>0) { $todomain=substr($todomain, $sp1+1); }
		$sp1=index($todomain, '>'); if ($sp1>0) { $todomain=substr($todomain, 0, $sp1); }
		$sp1=index($todomain, '@'); if ($sp1>0) { $todomain=substr($todomain, $sp1+1); }
		print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): todomain=|$todomain|\n");
		if (defined($TRANSPORT{$todomain}) && defined($SMTPAUTH{ $TRANSPORT{$todomain} })) {
			$mailfrom=$SMTPAUTH{ $TRANSPORT{$todomain} };
			print($FHANDLE "MAILFROM FOUND: mailfrom=|$mailfrom| todomain|$todomain| TRANSPORT{todomain}=|".$TRANSPORT{$todomain}."| SMTPAUTH{ TRANSPORT{todomain} }=|".$SMTPAUTH{ $TRANSPORT{$todomain} }."|\n");
			$RCPSMTPD->{'FROM'}=$mailfrom;
			$RCPHEADERS->{'From'}=$mailfrom;
			$RCPSMTPD->{'DATA'}=~s,From:.*\n,From: $mailfrom\n,; # do not use "g", replace only first occurence !!!
		}
		
		# for testing
		# return -1;
	}
	
	
	
	return 0;
}



1; # return status for include mode


