#!/usr/bin/perl -w

use strict;      # force definations for all vars an subroutines
use warnings;    # force check of unset variables in expressions
use diagnostics; # give var/code line number on faults

use File::Basename; # for basename(),



##########################################################################
# sub perl_content_filter($FHANDLE, \$retcntr, \$retmsgs, \%CPSMTPD, \%CPSOCKINFO, \%CPCONFIG, \%CPHEADERS)
# global   -----
# @param   handle $FHANDLE
# @param   int    \$retcntr    - reference int
# @param   string \$retmsgs    - reference string
# @param   HASH   \%CPSMTPD    - reference HASH
#          string $RCPSMTPD->{'HELO'}
#          string $RCPSMTPD->{'FROM'}
#          LIST   @{$RCPSMTPD->{'TO'}}
#          string $RCPSMTPD->{'DATA'}
# @param   HASH   \%CPSOCKINFO - reference HASH
#          string $RCPSOCKINFO->{'sockaddr'}
#          string $RCPSOCKINFO->{'sockhost'}
#          string $RCPSOCKINFO->{'sockport'}
#          string $RCPSOCKINFO->{'peeraddr'}
#          string $RCPSOCKINFO->{'peerhost'}
#          string $RCPSOCKINFO->{'peerport'}
# @param   HASH   \%CPCONFIG   - reference HASH
#          string $RCPCONFIG->{value}
# @param   HASH   \%CPHEADERS  - reference HASH
#          string $RCPHEADERS->{'From'}
#          string $RCPHEADERS->{'To'}
#          string $RCPHEADERS->{'Subject'}
#          string $RCPHEADERS->{'...'}
# @return  int    - # plugin $status==0  plugin returned status in references $retcntr+$retmsgs
# @return  int    - # plugin $status==-1 means DROP message
# @return  int    - # plugin $status==1  means ACCEPT message (messsage counter=0 and stop analyze message)
# @return  int    - # plugin $status==2  plugin modified content or headers
sub perl_content_filter {
	my ($FHANDLE, $Rretcntr, $Rretmsgs, $RCPSMTPD, $RCPSOCKINFO, $RCPCONFIG, $RCPHEADERS)=@_;
	my ($retval, $mailfrom, $hdrsfrom, @MAILTOTO, $hdrstoto);
	my ($line, $sp1, $sp2, $ipaddr);
	my (%NETS_CIDR_LIST, $netkey, $netval, $result);
	
	$retval=0;
	${$Rretcntr}=0; ${$Rretmsgs}='';
	$mailfrom=$RCPSMTPD->{'FROM'};
	$hdrsfrom=$RCPHEADERS->{'From'};
	@MAILTOTO=@{$RCPSMTPD->{'TO'}};
	$hdrstoto=$RCPHEADERS->{'To'};
	
	$ipaddr='';
	$sp1=index($RCPSMTPD->{DATA}, "\x{0A}");
	if (substr($RCPSMTPD->{DATA},0,length('Received:')) eq 'Received:' && $sp1>0) {
		# first line in message contains address received from host
		# Received: from xnd.nat.wbcd.pl (xnd.nat.wbcd.pl [10.0.0.3])        by cen05kde.xen.wbcd.pl (Postfix) with ESMTP id 784ADC1C6F      for <ola@cen05kde.xen.wbcd.pl>; Mon, 28 Apr 2014 01:52:10 +0200 (CEST)
		$line=substr($RCPSMTPD->{DATA}, 0, $sp1);
		$line=~s,[\r\n]+$,,g;
		print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): line:Received=|$line|\n");
		$sp1=index($line, '[');
		if ($sp1>=0) { $sp2=index($line, ']'); } else { $sp2=-1; }
		if ($sp1>=0 && $sp2>$sp1) {
			$ipaddr=$line;
			$ipaddr=substr($ipaddr, $sp1+1, $sp2-$sp1-1);
			print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): line:Received=|$line| ipaddr=|$ipaddr|\n");
		}
	}
	
	if (length($ipaddr)) {
		if (defined(${$RCPCONFIG}{'NETS_CIDR_LIST'})) {
			%NETS_CIDR_LIST=%{${$RCPCONFIG}{'NETS_CIDR_LIST'}};
			foreach $netkey (sort(keys(%NETS_CIDR_LIST))) {
				$netval=$NETS_CIDR_LIST{$netkey};
				if (substr($netkey,0,1) eq '#') { next; }
				print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): netkey=|$netkey| netval=|$netval|\n");
				$result=&check_ipaddr_match_network($ipaddr, $netkey);
				if ($result==1) {
					print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): MATCH: result=&check_ipaddr_match_network($ipaddr, $netkey): result=$result\n");
					if ($netval eq 'OK' || $netval eq 'NOK') {
						if ($netval eq 'OK' ) { $retval=1; ${$Rretcntr}=0;                              ${$Rretmsgs}='OK:WHITE LISTED' ; }
						if ($netval eq 'NOK') { $retval=1; ${$Rretcntr}=${$RCPCONFIG}{'spamcountpkts'}; ${$Rretmsgs}='NOK:BLACK LISTED'; }
						print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): MATCH: result=&check_ipaddr_match_network($ipaddr, $netkey): netval=$netval WHITE/BLACK LISTED retval=$retval\n");
						last;
					} else {
						${$Rretcntr}=${$Rretcntr}+$netval; ${$Rretmsgs}=${$Rretmsgs}."match($ipaddr,$netkey) ";
						print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): rowstatus=${$Rretcntr}:${$Rretmsgs}\n");
					}
				}
			}
			
		}
	}
	
	
	
	return $retval;
}



1; # return status for include mode


