#!/usr/bin/perl -w

use strict;      # force definations for all vars an subroutines
use warnings;    # force check of unset variables in expressions
use diagnostics; # give var/code line number on faults

use File::Basename; # for basename(),



##########################################################################
# sub perl_content_filter($FHANDLE, \$retcntr, \$retmsgs, \%CPSMTPD, \%CPSOCKINFO, \%CPCONFIG, \%CPHEADERS)
# global   -----
# @param   handle $FHANDLE
# @param   int    \$retcntr    - reference int
# @param   string \$retmsgs    - reference string
# @param   HASH   \%CPSMTPD    - reference HASH
#          string $RCPSMTPD->{'HELO'}
#          string $RCPSMTPD->{'FROM'}
#          LIST   @{$RCPSMTPD->{'TO'}}
#          string $RCPSMTPD->{'DATA'}
# @param   HASH   \%CPSOCKINFO - reference HASH
#          string $RCPSOCKINFO->{'sockaddr'}
#          string $RCPSOCKINFO->{'sockhost'}
#          string $RCPSOCKINFO->{'sockport'}
#          string $RCPSOCKINFO->{'peeraddr'}
#          string $RCPSOCKINFO->{'peerhost'}
#          string $RCPSOCKINFO->{'peerport'}
# @param   HASH   \%CPCONFIG   - reference HASH
#          string $RCPCONFIG->{value}
# @param   HASH   \%CPHEADERS  - reference HASH
#          string $RCPHEADERS->{'From'}
#          string $RCPHEADERS->{'To'}
#          string $RCPHEADERS->{'Subject'}
#          string $RCPHEADERS->{'...'}
# @return  int    - # plugin $status==0  plugin returned status in references $retcntr+$retmsgs
# @return  int    - # plugin $status==-1 means DROP message
# @return  int    - # plugin $status==1  means ACCEPT message (messsage counter=0 and stop analyze message)
# @return  int    - # plugin $status==2  plugin modified content or headers
sub perl_content_filter {
	my ($FHANDLE, $Rretcntr, $Rretmsgs, $RCPSMTPD, $RCPSOCKINFO, $RCPCONFIG, $RCPHEADERS, $REMLSPARSED)=@_;
	my ($retval, $mailfrom, $hdrsfrom, @MAILTOTO, $hdrstoto);
	my ($hrdssize, $bodyorig, $bodytext, $hrefperc, $htmlperc);
	my ($key, $contenttype);
	my ($conttext, $conthtml, $html2text, $sizetexthtml, %ATTACH);
	
	$retval=0;
	${$Rretcntr}=0; ${$Rretmsgs}='';
	$mailfrom=$RCPSMTPD->{'FROM'};
	$hdrsfrom=$RCPHEADERS->{'From'};
	@MAILTOTO=@{$RCPSMTPD->{'TO'}};
	$hdrstoto=$RCPHEADERS->{'To'};
	
	
	
	$contenttype='';
	foreach $key (sort(keys(%{$RCPHEADERS}))) {
		#print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): $key=|".${$RCPHEADERS}{$key}."|\n");
		if (lc($key) eq 'content-type') { $contenttype=${$RCPHEADERS}{$key}; }
	}
	# no Content-Type: assume: "Content-Type: text/plain"
	if (length($contenttype)<=0) {
		$contenttype='text/plain';
	}
	
	
	if (length($contenttype)>0 && index(lc($contenttype),'text/plain')>=0) {
		$hrdssize=0;
		$hrdssize=index($RCPSMTPD->{DATA},"\x{0D}\x{0A}\x{0D}\x{0A}"); if ($hrdssize>0) { $hrdssize=$hrdssize+4; }
		if ($hrdssize<0) {$hrdssize=index($RCPSMTPD->{DATA},"\x{0D}\x{0D}"); if ($hrdssize>0) { $hrdssize=$hrdssize+2; } }
		if ($hrdssize<0) {$hrdssize=index($RCPSMTPD->{DATA},"\x{0A}\x{0A}"); if ($hrdssize>0) { $hrdssize=$hrdssize+2; } }
		if ($hrdssize<0) {$hrdssize=0;}
		print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): hrdssize=$hrdssize\n");
		$bodyorig=substr($RCPSMTPD->{DATA}, $hrdssize);
		$bodytext=$bodyorig;
		$bodytext=~s,http://[^/]*/[^ \r\n]*,,g;
		print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): length(\$bodyorig)=".length($bodyorig)."\n");
		print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): length(\$bodytext)=".length($bodytext)."\n");
		print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): length(\$bodyorig)-length(\$bodytext)=".( length($bodyorig) - length($bodytext) )."\n");
		if (length($bodyorig)>0) {
			$hrefperc=( length($bodyorig) - length($bodytext) ) / length($bodyorig);
			print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): hrefperc=$hrefperc\n");
			
			if ($hrefperc>$RCPCONFIG->{'body_cont_href_percent'}) {
				${$Rretcntr}=${$Rretcntr}+$RCPCONFIG->{'body_cont_href_pkts'};
				#${$Rretmsgs}=${$Rretmsgs}." hrefperc=$hrefperc ".( length($bodyorig) - length($bodytext) )."/".length($bodyorig)."";
				${$Rretmsgs}=${$Rretmsgs}.sprintf(" hrefperc=$hrefperc \%d/\%d", length($bodyorig) - length($bodytext), length($bodyorig));
			}
		} else {
			&logsinfo_write(basename(__FILE__).':'.__LINE__.':'.(caller(0))[3], "WARNING: UNFORTUNATELY: if (length(\$bodyorig)>0):else: length(\$bodyorig)=".length($bodyorig)."");
		}
	}
	
	
	
	if (length($contenttype)>0 && index(lc($contenttype),'text/html')>=0) {
		$hrdssize=0;
		$hrdssize=index($RCPSMTPD->{DATA},"\x{0D}\x{0A}\x{0D}\x{0A}"); if ($hrdssize>0) { $hrdssize=$hrdssize+4; }
		if ($hrdssize<0) {$hrdssize=index($RCPSMTPD->{DATA},"\x{0D}\x{0D}"); if ($hrdssize>0) { $hrdssize=$hrdssize+2; } }
		if ($hrdssize<0) {$hrdssize=index($RCPSMTPD->{DATA},"\x{0A}\x{0A}"); if ($hrdssize>0) { $hrdssize=$hrdssize+2; } }
		if ($hrdssize<0) {$hrdssize=0;}
		print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): hrdssize=$hrdssize\n");
		$bodyorig=substr($RCPSMTPD->{DATA}, $hrdssize);
		$bodytext=$bodyorig;
		$bodytext=~s,<[^>]*>,,g;
		print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): length(\$bodyorig)=".length($bodyorig)."\n");
		print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): length(\$bodytext)=".length($bodytext)."\n");
		print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): length(\$bodyorig)-length(\$bodytext)=".( length($bodyorig) - length($bodytext) )."\n");
		if (length($bodyorig)>0) {
			$htmlperc=( length($bodyorig) - length($bodytext) ) / length($bodyorig);
			print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): htmlperc=$htmlperc\n");
			
			if ($htmlperc>$RCPCONFIG->{'body_cont_html_percent'}) {
				${$Rretcntr}=${$Rretcntr}+$RCPCONFIG->{'body_cont_href_pkts'};
				#${$Rretmsgs}=${$Rretmsgs}." hrefperc=$htmlperc ".( length($bodyorig) - length($bodytext) )."/".length($bodyorig)."";
				${$Rretmsgs}=${$Rretmsgs}.sprintf(" hrefperc=$htmlperc \%d/\%d", length($bodyorig) - length($bodytext), length($bodyorig));
			}
		} else {
			&logsinfo_write(basename(__FILE__).':'.__LINE__.':'.(caller(0))[3], "WARNING: UNFORTUNATELY: if (length(\$bodyorig)>0):else: length(\$bodyorig)=".length($bodyorig)."");
		}
	}
	
	
	
	if (index(lc($contenttype),'multipart/')>=0 || index(lc($contenttype),'boundary')>=0) {
		$conttext=&message_parsed_bodytext($REMLSPARSED);
		$conthtml=&message_parsed_bodyhtml($REMLSPARSED);
		$html2text=$conthtml;
		$html2text=~s,<[^>]*>,,g;
		%ATTACH  =&message_parsed_files   ($REMLSPARSED);
		#print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): conttext=|$conttext|\n");
		#print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): conthtml=|$conthtml|\n");
		#print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): html2text=|$html2text|\n");
		print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): length(\$conttext)=".length($conttext)."\n");
		print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): length(\$conthtml)=".length($conthtml)."\n");
		print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): length(\$html2text)=".length($html2text)."\n");
		foreach $key (keys(%ATTACH)) { print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): key=|\%ATTACH[$key]|\n"); }
		
		print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): size:conttext=".length($conttext)." size:conthtml=".length($conthtml)." site:html2text=".length($html2text)."\n");
		if (length($conttext)<10 && length($conthtml)>10) {
			${$Rretcntr}=${$Rretcntr}+$RCPCONFIG->{'body_cont_html_only_pkts'};
			#${$Rretmsgs}=${$Rretmsgs}." text=".length($conttext)."<10 && html=".length($conthtml).">10";
			${$Rretmsgs}=${$Rretmsgs}.sprintf(" HTMLONLY(text=\%d<10 && html=\%d>10)", length($conttext), length($conthtml));
		}
		
		if (length($conttext)>0 && length($html2text)>0) {
			$sizetexthtml=length($conttext)/length($html2text);
			$sizetexthtml=int(1000*$sizetexthtml)/1000;
			print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): sizetexthtml=$sizetexthtml\n");
			if ($sizetexthtml>2 || $sizetexthtml<0.5) {
				${$Rretcntr}=${$Rretcntr}+0-30;
				#${$Rretmsgs}=${$Rretmsgs}." size=$sizetexthtml ".length($conttext)."/".length($html2text)." ";
				${$Rretmsgs}=${$Rretmsgs}.sprintf(" text:html:diff=$sizetexthtml \%d/\%d", length($conttext), length($html2text));
			}
		}
		
		# text/plain
		if (length($conttext)>0) {
			$bodyorig=$conttext;
			$bodytext=$bodyorig;
			$bodytext=~s,http://[^/]*/[^ \r\n]*,,g;
			#print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): \$bodyorig=|$bodyorig|\n");
			#print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): \$bodytext=|$bodytext|\n");
			print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): length(\$bodyorig)=".length($bodyorig)."\n");
			print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): length(\$bodytext)=".length($bodytext)."\n");
			print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): length(\$bodyorig)-length(\$bodytext)=".( length($bodyorig) - length($bodytext) )."\n");
			
			if (length($bodyorig)>0) {
				$hrefperc=( length($bodyorig) - length($bodytext) ) / length($bodyorig);
				print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): hrefperc=$hrefperc\n");
				
				if ($hrefperc>$RCPCONFIG->{'body_cont_href_percent'}) {
					${$Rretcntr}=${$Rretcntr}+$RCPCONFIG->{'body_cont_href_pkts'};
					#${$Rretmsgs}=${$Rretmsgs}." hrefperc=$hrefperc ".( length($bodyorig) - length($bodytext) )."/".length($bodyorig)."";
					${$Rretmsgs}=${$Rretmsgs}.sprintf(" hrefperc=$hrefperc \%d/\%d", length($bodyorig) - length($bodytext), length($bodyorig));
				}
			} else {
				&logsinfo_write(basename(__FILE__).':'.__LINE__.':'.(caller(0))[3], "WARNING: if (length(\$conttext)>0):length(\$conttext)=".length($conttext)." UNFORTUNATELY: if (length(\$bodyorig)>0):else: length(\$bodyorig)=".length($bodyorig)."");
			}
		}
		
		# text/html
		if (length($conthtml)>0) {
			$bodyorig=$conthtml;
			$bodytext=$bodyorig;
			$bodytext=~s,<[^>]*>,,g;
			print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): length(\$bodyorig)=".length($bodyorig)."\n");
			print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): length(\$bodytext)=".length($bodytext)."\n");
			print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): length(\$bodyorig)-length(\$bodytext)=".( length($bodyorig) - length($bodytext) )."\n");
			if (length($bodyorig)>0) {
				$htmlperc=( length($bodyorig) - length($bodytext) ) / length($bodyorig);
				print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): htmlperc=$htmlperc body_cont_html_percent=".$RCPCONFIG->{'body_cont_html_percent'}."\n");
				
				if ($htmlperc>$RCPCONFIG->{'body_cont_html_percent'}) {
					${$Rretcntr}=${$Rretcntr}+$RCPCONFIG->{'body_cont_href_pkts'};
					#${$Rretmsgs}=${$Rretmsgs}." hrefperc=$htmlperc ".( length($bodyorig) - length($bodytext) )."/".length($bodyorig)."";
					${$Rretmsgs}=${$Rretmsgs}.sprintf(" htmlperc=$htmlperc \%d/\%d", length($bodyorig) - length($bodytext), length($bodyorig));
				}
			} else {
				&logsinfo_write(basename(__FILE__).':'.__LINE__.':'.(caller(0))[3], "WARNING: if (length(\$conthtml)>0):length(\$conthtml)=".length($conthtml)." UNFORTUNATELY: if (length(\$bodyorig)>0):else: length(\$bodyorig)=".length($bodyorig)."");
			}
		}
	}
	
	
	
	if (length(${$Rretmsgs})>0) {   while (ord(substr(${$Rretmsgs},0,1))==0x20 || ord(substr(${$Rretmsgs},0,1))==0x09) { ${$Rretmsgs}=substr(${$Rretmsgs}, 1); }   }
	print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): status=".${$Rretcntr}.":".${$Rretmsgs}."\n");
	
	return 0;
}



1; # return status for include mode


