#!/usr/bin/perl -w

use strict;      # force definations for all vars an subroutines
use warnings;    # force check of unset variables in expressions
use diagnostics; # give var/code line number on faults

use File::Basename; # for basename(),



##########################################################################
# sub perl_content_filter($FHANDLE, \$retcntr, \$retmsgs, \%CPSMTPD, \%CPSOCKINFO, \%CPCONFIG, \%CPHEADERS)
# global   -----
# @param   handle $FHANDLE
# @param   int    \$retcntr    - reference int
# @param   string \$retmsgs    - reference string
# @param   HASH   \%CPSMTPD    - reference HASH
#          string $RCPSMTPD->{'HELO'}
#          string $RCPSMTPD->{'FROM'}
#          LIST   @{$RCPSMTPD->{'TO'}}
#          string $RCPSMTPD->{'DATA'}
# @param   HASH   \%CPSOCKINFO - reference HASH
#          string $RCPSOCKINFO->{'sockaddr'}
#          string $RCPSOCKINFO->{'sockhost'}
#          string $RCPSOCKINFO->{'sockport'}
#          string $RCPSOCKINFO->{'peeraddr'}
#          string $RCPSOCKINFO->{'peerhost'}
#          string $RCPSOCKINFO->{'peerport'}
# @param   HASH   \%CPCONFIG   - reference HASH
#          string $RCPCONFIG->{value}
# @param   HASH   \%CPHEADERS  - reference HASH
#          string $RCPHEADERS->{'From'}
#          string $RCPHEADERS->{'To'}
#          string $RCPHEADERS->{'Subject'}
#          string $RCPHEADERS->{'...'}
# @return  int    - # plugin $status==0  plugin returned status in references $retcntr+$retmsgs
# @return  int    - # plugin $status==-1 means DROP message
# @return  int    - # plugin $status==1  means ACCEPT message (messsage counter=0 and stop analyze message)
# @return  int    - # plugin $status==2  plugin modified content or headers
sub perl_content_filter {
	my ($FHANDLE, $Rretcntr, $Rretmsgs, $RCPSMTPD, $RCPSOCKINFO, $RCPCONFIG, $RCPHEADERS)=@_;
	my ($retval, $mailfrom, $hdrsfrom, @MAILTOTO, $hdrstoto, $contenttype, $messageid);
	my ($receivedlast, $receivedhelo, $receivedipname, $receivedipaddr, $receivedfirst);
	my (@PREGLIST, $pregline, $pregkey, $pregval, $headkey, $headlist, $key, $sp1, $sp2, $sp3, $sp4, $catch, $found);
	
	$retval=0;
	${$Rretcntr}=0; ${$Rretmsgs}='';
	$mailfrom=$RCPSMTPD->{'FROM'};
	$hdrsfrom=$RCPHEADERS->{'From'};
	@MAILTOTO=@{$RCPSMTPD->{'TO'}};
	$hdrstoto=$RCPHEADERS->{'To'};
	
	print($FHANDLE "\n");
	print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): \$RCPHEADERS: BEGIN\n");
	foreach $key (sort(keys(%{$RCPHEADERS}))) {
		print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): \$RCPHEADERS{$key}=[|".${$RCPHEADERS}{$key}."|]\n");
	}
	print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): \$RCPHEADERS: END\n");
	print($FHANDLE "\n");
	
	$contenttype  ='';
	$messageid    ='';
	$receivedfirst='';
	$receivedlast ='';
	foreach $key (sort(keys(%{$RCPHEADERS}))) {
		###print($FHANDLE "$key=|".${$RCPHEADERS}{$key}."|\n");
		if (lc($key) eq 'content-type') { $contenttype=${$RCPHEADERS}{$key}; }
		if (lc($key) eq 'message-id'  ) { $messageid  =${$RCPHEADERS}{$key}; }
		if (substr($key,0,length('Received')) eq 'Received') { $receivedlast=${$RCPHEADERS}{$key}; }
		if (length($receivedfirst)<=0 && substr($key,0,length('Received')) eq 'Received') { $receivedfirst=${$RCPHEADERS}{$key}; }
	}
	if (defined(${$RCPHEADERS}{'Received0'})) { $receivedfirst=${$RCPHEADERS}{'Received0'}; }
	print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): receivedlast =|$receivedlast|\n");
	print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): receivedfirst=|$receivedfirst|\n");
	
	
	
	#
	# Content-Type: text/html
	#
	if (length($contenttype)>0 && index(lc($contenttype),'text/html')>=0) {
		${$Rretcntr}=${$Rretcntr}+${$RCPCONFIG}{'header_texthtml_pkts'};
		${$Rretmsgs}.=" (Content-Type:text/html)";
	}
	
	
	
	#
	# HEADERS:required
	#
	if (defined(${$RCPCONFIG}{'header_required_keys'}) && length(${$RCPCONFIG}{'header_required_keys'})) {
		print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): header_required_pkts=${$RCPCONFIG}{'header_required_pkts'} header_required_keys=|${$RCPCONFIG}{'header_required_keys'}|\n");
		$headlist='';
		@PREGLIST=split(/\|/, ${$RCPCONFIG}{'header_required_keys'});
		foreach $pregline (@PREGLIST) {
			if (index($pregline,'=')>0) { $pregkey=substr($pregline, 0, index($pregline,'=')); $pregval=substr($pregline, index($pregline,'=')+1); }
			else                        { $pregkey=$pregline;                                  $pregval=${$RCPCONFIG}{'header_required_pkts'};     }
			if ($pregval=~m/^[+-]?[0-9]+$/) { $pregval=int($pregval);                         }
			else                            { $pregval=${$RCPCONFIG}{'header_required_pkts'}; }
			$found=0;
			foreach $headkey (sort(keys(%{$RCPHEADERS}))) {
				if ($headkey=~m/$pregkey/ && length(${$RCPHEADERS}{$headkey})>0) { $found=1; }
			}
			if ($found==0) {
				${$Rretcntr}=${$Rretcntr}+$pregval;
				if (substr($pregkey,0,1) eq '^') { $headlist=$headlist.substr($pregkey,1).','; }
				else                             { $headlist=$headlist.$pregkey.','; }
			}
		}
		if (length($headlist)>0) {
			$headlist=substr($headlist, 0, -1);
			${$Rretmsgs}.=" (MISSING:headers($headlist))";
		}
	}
	
	
	
	#
	# HEADERS:extra
	#
	if (defined(${$RCPCONFIG}{'header_extra_keys'}) && length(${$RCPCONFIG}{'header_extra_keys'})) {
		print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): header_extra_pkts=${$RCPCONFIG}{'header_extra_pkts'} header_extra_keys=|${$RCPCONFIG}{'header_extra_keys'}|\n");
		$headlist='';
		@PREGLIST=split(/\|/, ${$RCPCONFIG}{'header_extra_keys'});
		foreach $pregline (@PREGLIST) {
			if (index($pregline,'=')>0) { $pregkey=substr($pregline, 0, index($pregline,'=')); $pregval=substr($pregline, index($pregline,'=')+1); }
			else                        { $pregkey=$pregline;                                  $pregval=${$RCPCONFIG}{'header_extra_pkts'};        }
			if ($pregval=~m/^[+-]?[0-9]+$/) { $pregval=int($pregval);                      }
			else                            { $pregval=${$RCPCONFIG}{'header_extra_pkts'}; }
			foreach $headkey (sort(keys(%{$RCPHEADERS}))) {
				if ($headkey=~m/$pregkey/) {
					${$Rretcntr}=${$Rretcntr}+$pregval;
					#${$Rretmsgs}.=" (header=m/$pregkey/)";
					if (substr($pregkey,0,1) eq '^') { $headlist=$headlist.substr($pregkey,1).','; }
					else                             { $headlist=$headlist.$pregkey.','; }
				}
			}
		}
		if (length($headlist)>0) {
			$headlist=substr($headlist, 0, -1);
			${$Rretmsgs}.=" (EXTRA:headers($headlist))";
		}
	}
	
	
	
	###############################
	#####   Received: FIRST   #####
	#####   Received: ***     #####
	#####   Received: ***     #####
	###############################
	# received first: check line: Authenticated sender: STOP filtering,
	if (length($receivedfirst)>0 && index($receivedfirst,'Authenticated sender:')>0) {
		$retval=1; ${$Rretcntr}=0; ${$Rretmsgs}='OK:Authenticated sender'; return $retval;
	}
	
	if (length($receivedfirst)>0 && substr($receivedfirst,0,5) eq 'from ') {
		# from xnd.nat.wbcd.pl (xnd.nat.wbcd.pl [10.0.0.3])        by cen05kde.xen.wbcd.pl (Postfix) with ESMTP id 784ADC1C6F      for <ola@cen05kde.xen.wbcd.pl>; Mon, 28 Apr 2014 01:52:10 +0200 (CEST)
		$receivedfirst=substr($receivedfirst, 5);
		# xnd.nat.wbcd.pl (xnd.nat.wbcd.pl [10.0.0.3])        by cen05kde.xen.wbcd.pl (Postfix) with ESMTP id 784ADC1C6F      for <ola@cen05kde.xen.wbcd.pl>; Mon, 28 Apr 2014 01:52:10 +0200 (CEST)
		
		$receivedipname=$receivedfirst;
		$sp1=index($receivedipname, '(');
		$sp2=index($receivedipname, ')');
		$sp3=index($receivedipname, '[');
		$sp4=index($receivedipname, ']');
		print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): receivedipname=|$sp1|$sp2|$sp3|$sp4|=|$receivedipname|\n");
		
		# xnd.nat.wbcd.pl (xnd.nat.wbcd.pl [10.0.0.3])        by cen05kde.xen.wbcd.pl (Postfix) with ESMTP id 784ADC1C6F      for <ola@cen05kde.xen.wbcd.pl>; Mon, 28 Apr 2014 01:52:10 +0200 (CEST)
		#                 |                |        ||
		#                sp1              sp3     sp4sp2
		if ($sp1>=0 && $sp2>0 && $sp3>0 && $sp4>0 && $sp2>$sp1 && $sp4>$sp3 && $sp4<$sp2) {
			
			$receivedhelo=$receivedfirst;
			if (index($receivedhelo,' ')>0) { $receivedhelo=substr($receivedhelo, 0, index($receivedhelo,' ')); }
			# xnd.nat.wbcd.pl
			print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): receivedhelo=|$receivedhelo|\n");
			
			$receivedipname=substr($receivedipname, $sp1+1);
			# (xnd.nat.wbcd.pl [10.0.0.3])
			$sp2=index($receivedipname,')');
			$receivedipaddr=$receivedipname=substr($receivedipname, 0, $sp2);
			# xnd.nat.wbcd.pl [10.0.0.3]
			if (index($receivedipname,' ')>0) { $receivedipname=substr($receivedipname, 0, index($receivedipname,' ')); }
			# xnd.nat.wbcd.pl
			print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): receivedipname=|$receivedipname|\n");
			if ($receivedipname ne $receivedhelo) {
				${$Rretcntr}=${$Rretcntr}-20;
				${$Rretmsgs}.=" (RevIPADDR:IPNAME ne HELO)";
			}
			
			$sp3=index($receivedipaddr,'[');
			$sp4=index($receivedipaddr,']');
			print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): receivedipaddr=|$sp3|$sp4|=|$receivedipaddr|\n");
			# xnd.nat.wbcd.pl [10.0.0.3]
			if ($sp3>0 && $sp4>0 && $sp4>$sp3) {
				$receivedipaddr=substr($receivedipaddr, $sp3+1);
				$sp4=index($receivedipaddr,']');
				$receivedipaddr=substr($receivedipaddr, 0, $sp4);
				# 10.0.0.3
				print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): receivedipaddr=|$receivedipaddr|\n");
				my @IPADDROCT=split(/\./, $receivedipaddr);
				if ($#IPADDROCT+1==4) {
					if (index($receivedipname,$IPADDROCT[0])>=0 && index($receivedipname,$IPADDROCT[1])>=0 && index($receivedipname,$IPADDROCT[2])>=0 && index($receivedipname,$IPADDROCT[3])>=0) {
						${$Rretcntr}=${$Rretcntr}-20;
						${$Rretmsgs}.=" (dynamic: IPADDR in IPNAME)";
					}
				}
			}
		} # if ($sp1>=0 && $sp2>0 && $sp3>0 && $sp4>0 && $sp2>$sp1 && $sp4>$sp3 && $sp4<$sp2)
		
		
		
		$receivedipname=$receivedfirst;
		$sp1=index($receivedipname, '(HELO ');
		$sp2=index($receivedipname, ')');
		# from unknown (HELO localhost) (j.rothe@csource.com@68.51.93.39)
		# unknown (HELO localhost) (j.rothe@csource.com@68.51.93.39)
		if ($sp1>=0 && $sp2>0 && $sp2>$sp1) {
			$receivedhelo=$receivedipname;
			$sp1=index($receivedhelo, '(HELO ');
			$receivedhelo=substr($receivedhelo, $sp1+6);
			$sp2=index($receivedhelo, ')');
			$receivedhelo=substr($receivedhelo, 0, $sp1);
			# localhost
			print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): receivedhelo=|$receivedhelo|\n");
			
			if (index($receivedipname,' ')>0) { $receivedipname=substr($receivedipname, 0, index($receivedipname,' ')); }
			# unknown
			print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): receivedipname=|$receivedipname|\n");
		} # if ($sp1>0 && $sp2>0 && $sp2>$sp1)
		
		
		
		# from temp-unknown [41.189.228.132]
		
		
		
	} # if (length($receivedfirst)>0 && substr($receivedfirst,0,5) eq 'from ')
	
	
	
	
	
	##############################
	#####   Received: ***    #####
	#####   Received: ***    #####
	#####   Received: LAST   #####
	##############################
# 	if (length($receivedlast)>0 && substr($receivedlast,0,5) eq 'from ') {
# 		$receivedlast=substr($receivedlast, 5);
# 		# from unknown (HELO localhost) (j.rothe@csource.com@68.51.93.39)
# 		# unknown (HELO localhost) (j.rothe@csource.com@68.51.93.39)
# 		# from 88.198.158.184 (localhost [127.0.0.1]) by playermaximus.eu
# 		# from localhost ([127.0.0.1]:59231)
# 		
# 		$catch=0;
# 		$sp1=index($receivedlast, '(HELO ');
# 		$sp2=index($receivedlast, ')');
# 		$receivedipname=$receivedlast;
# 		# from unknown (HELO localhost) (j.rothe@csource.com@68.51.93.39)
# 		# unknown (HELO localhost) (j.rothe@csource.com@68.51.93.39)
# 		if ($catch==0 && $sp1>=0 && $sp2>0 && $sp2>$sp1) {
# 			$catch=1;
# 			$receivedhelo=$receivedlast;
# 			$sp1=index($receivedhelo, '(HELO ');
# 			$receivedhelo=substr($receivedhelo, $sp1+6);
# 			$sp2=index($receivedhelo, ')');
# 			$receivedhelo=substr($receivedhelo, 0, $sp2);
# 			# localhost
# 			print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): receivedhelo=|$receivedhelo|\n");
# 			
# 			if (index($receivedipname,' ')>0) { $receivedipname=substr($receivedipname, 0, index($receivedipname,' ')); }
# 			# unknown
# 			print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): receivedipname=|$receivedipname|\n");
# 			
# 			if (index($receivedhelo,  'localhost')>=0) { ${$Rretcntr}=${$Rretcntr}-10; ${$Rretmsgs}.=" (HELO localhost)"; }
# 			if (index($receivedhelo,  '.')<=0)         { ${$Rretcntr}=${$Rretcntr}-10; ${$Rretmsgs}.=" (HELO name without domain)"; }
# 			if (index($receivedipname,'127.0.0.1')>=0) { ${$Rretcntr}=${$Rretcntr}-10; ${$Rretmsgs}.=" (Received from 127.0.0.1)" }
# 			if (index($receivedipname,'unknown')>=0)   { ${$Rretcntr}=${$Rretcntr}-10; ${$Rretmsgs}.=" (Received from unknown)" }
# 			
# 		} # if ($sp1>0 && $sp2>0 && $sp2>$sp1)
# 		
# 		
# 		
# 		$sp1=index($receivedlast, '[');
# 		$sp2=index($receivedlast, ']');
# 		$sp3=index($receivedlast, '(helo');
# 		$sp4=index($receivedlast, ')');
# 		# from [100.12.129.193] (helo=usuflxogq.tvypet.net) by pttnet206-199.ptt.rs with esmtpa (Exim 4.69) (envelope-from ) id 1MMK27-2754ac-NI for pieniu@10g.pl; Fri, 19 Jul 2013 17:44:48 +0100
# 		# [100.12.129.193] (helo=usuflxogq.tvypet.net) by pttnet206-199.ptt.rs with esmtpa (Exim 4.69) (envelope-from ) id 1MMK27-2754ac-NI for pieniu@10g.pl; Fri, 19 Jul 2013 17:44:48 +0100
# 		if ($catch==0 && $sp1>=0 && $sp2>=0 && $sp2>$sp1 && $sp3>0 && $sp4>0 && $sp4>$sp3) {
# 			$catch=1;
# 			$receivedipaddr=$receivedlast;
# 			$receivedipaddr=substr($receivedipaddr, $sp1+1);
# 			$sp2=index($receivedipaddr, ']');
# 			$receivedipaddr=substr($receivedipaddr, 0, $sp2);
# 			# 100.12.129.193
# 			print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): receivedipaddr=|$receivedipaddr|\n");
# 			
# 			$receivedhelo=$receivedlast;
# 			$receivedhelo=substr($receivedhelo, $sp3+6);
# 			$sp4=index($receivedhelo, ')');
# 			$receivedhelo=substr($receivedhelo, 0, $sp4);
# 			# usuflxogq.tvypet.net
# 			print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): receivedhelo=|$receivedhelo|\n");
# 			
# 			if (index($receivedhelo,  'localhost')>=0) { ${$Rretcntr}=${$Rretcntr}-10; ${$Rretmsgs}.=" (HELO localhost)"; }
# 			if (index($receivedhelo,  '.')<=0)         { ${$Rretcntr}=${$Rretcntr}-10; ${$Rretmsgs}.=" (HELO name without domain)"; }
# 		}
# 		
# 		
# 		
# 		# from localhost ([127.0.0.1]:59231)
# 		# from 178235055122.warszawa.vectranet.pl ([178.235.55.122] helo=B40F50990A)
# 		$sp1=index($receivedlast, '(');
# 		$sp2=index($receivedlast, ')');
# 		$sp3=index($receivedlast, '[');
# 		$sp4=index($receivedlast, ']');
# 		if ($catch==0 && $sp1>0 && $sp2>0 && $sp3>=0 && $sp4>=0 && $sp2>$sp1 && $sp3==$sp1+1 && $sp4>$sp3 && $sp4<$sp2) {
# 			$catch=1;
# 			$receivedhelo=$receivedlast;
# 			if (substr($receivedhelo,0,5) eq 'from ') { $receivedhelo=substr($receivedhelo, 5); }
# 			$sp2=index($receivedhelo, ' ');
# 			$receivedhelo=substr($receivedhelo, 0, $sp2);
# 			# localhost
# 			if (index($receivedlast,' helo=')>0) {
# 				$receivedhelo=$receivedlast;
# 				$receivedhelo=substr($receivedhelo, index($receivedlast,' helo=')+length(' helo-'));
# 				$receivedhelo=substr($receivedhelo, 0, index($receivedhelo,' '));
# 				$receivedhelo=substr($receivedhelo, 0, length($receivedhelo)-1);
# 				# B40F50990A
# 			}
# 			print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): receivedhelo=|$receivedhelo|\n");
# 			
# 			$receivedipaddr=$receivedlast;
# 			$receivedipaddr=substr($receivedipaddr, $sp3+1);
# 			$sp4=index($receivedipaddr, ']');
# 			$receivedipaddr=substr($receivedipaddr, 0, $sp4);
# 			# 127.0.0.1
# 			print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): receivedipaddr=|$receivedipaddr|\n");
# 			
# 			if (index($receivedhelo,  'localhost')>=0) { ${$Rretcntr}=${$Rretcntr}-10; ${$Rretmsgs}.=" (HELO localhost)"; }
# 			if (index($receivedhelo,  '.')<=0)         { ${$Rretcntr}=${$Rretcntr}-10; ${$Rretmsgs}.=" (HELO name without domain)"; }
# 			if (index($receivedipname,'127.0.0.1')>=0) { ${$Rretcntr}=${$Rretcntr}-10; ${$Rretmsgs}.=" (Received from 127.0.0.1)" }
# 			if (index($receivedipname,'unknown')>=0)   { ${$Rretcntr}=${$Rretcntr}-10; ${$Rretmsgs}.=" (Received from unknown)" }
# 		}
# 		
# 		
# 		
# 		# from 88.198.158.184 (localhost [127.0.0.1]) by playermaximus.eu
# 		$sp1=index($receivedlast, '(');
# 		$sp2=index($receivedlast, ')');
# 		$sp3=index($receivedlast, '[');
# 		$sp4=index($receivedlast, ']');
# 		if ($catch==0 && $sp1>0 && $sp2>0 && $sp3>=0 && $sp4>=0 && $sp2>$sp1 && $sp3>$sp1 && $sp4>$sp3 && $sp4<$sp2) {
# 			$catch=1;
# 			$receivedipaddr=$receivedlast;
# 			$receivedipaddr=substr($receivedipaddr, $sp3+1);
# 			$sp4=index($receivedipaddr, ']');
# 			$receivedipaddr=substr($receivedipaddr, 0, $sp4);
# 			# 127.0.0.1
# 			print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): receivedipaddr=|$receivedipaddr|\n");
# 			
# 			$receivedhelo=$receivedlast;
# 			$receivedhelo=substr($receivedhelo, $sp1);
# 			$sp2=index($receivedhelo, ' ');
# 			$receivedhelo=substr($receivedhelo, 0, $sp2);
# 			# localhost
# 			print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): receivedhelo=|$receivedhelo|\n");
# 			
# 			if (index($receivedhelo,  'localhost')>=0) { ${$Rretcntr}=${$Rretcntr}-10; ${$Rretmsgs}.=" (HELO localhost)"; }
# 			if (index($receivedhelo,  '.')<=0)         { ${$Rretcntr}=${$Rretcntr}-10; ${$Rretmsgs}.=" (HELO name without domain)"; }
# 			if (index($receivedipname,'127.0.0.1')>=0) { ${$Rretcntr}=${$Rretcntr}-10; ${$Rretmsgs}.=" (Received from 127.0.0.1)" }
# 			if (index($receivedipname,'unknown')>=0)   { ${$Rretcntr}=${$Rretcntr}-10; ${$Rretmsgs}.=" (Received from unknown)" }
# 		}
# 		
# 		
# 		
# 	} # if (length($receivedlast)>0 && substr($receivedlast,0,5) eq 'from ')
	
	
	
	
	
	#foreach $key (keys(%{$RCPHEADERS})) {
	#	if (substr($key,0,length('Received')) eq 'Received') {  }
	#}
	
	
	
	print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): status=".${$Rretcntr}.":".${$Rretmsgs}."\n");
	
	return $retval;
}



1; # return status for include mode


