#!/usr/bin/perl -w

use strict;      # force definations for all vars an subroutines
use warnings;    # force check of unset variables in expressions
use diagnostics; # give var/code line number on faults

use File::Basename; # for basename(),



##########################################################################
# sub perl_content_filter($FHANDLE, \$retcntr, \$retmsgs, \%CPSMTPD, \%CPSOCKINFO, \%CPCONFIG, \%CPHEADERS)
# global   -----
# @param   handle $FHANDLE
# @param   int    \$retcntr    - reference int
# @param   string \$retmsgs    - reference string
# @param   HASH   \%CPSMTPD    - reference HASH
#          string $RCPSMTPD->{'HELO'}
#          string $RCPSMTPD->{'FROM'}
#          LIST   @{$RCPSMTPD->{'TO'}}
#          string $RCPSMTPD->{'DATA'}
# @param   HASH   \%CPSOCKINFO - reference HASH
#          string $RCPSOCKINFO->{'sockaddr'}
#          string $RCPSOCKINFO->{'sockhost'}
#          string $RCPSOCKINFO->{'sockport'}
#          string $RCPSOCKINFO->{'peeraddr'}
#          string $RCPSOCKINFO->{'peerhost'}
#          string $RCPSOCKINFO->{'peerport'}
# @param   HASH   \%CPCONFIG   - reference HASH
#          string $RCPCONFIG->{value}
# @param   HASH   \%CPHEADERS  - reference HASH
#          string $RCPHEADERS->{'From'}
#          string $RCPHEADERS->{'To'}
#          string $RCPHEADERS->{'Subject'}
#          string $RCPHEADERS->{'...'}
# @return  int    - # plugin $status==0  plugin returned status in references $retcntr+$retmsgs
# @return  int    - # plugin $status==-1 means DROP message
# @return  int    - # plugin $status==1  means ACCEPT message (messsage counter=0 and stop analyze message)
# @return  int    - # plugin $status==2  plugin modified content or headers
sub perl_content_filter {
	my ($FHANDLE, $Rretcntr, $Rretmsgs, $RCPSMTPD, $RCPSOCKINFO, $RCPCONFIG, $RCPHEADERS)=@_;
	my ($retval, $mailfrom, $hdrsfrom);
	my ($mailcleanfrom,  $hdrscleanfrom);
	my ($maildomainfrom, $hdrsdomainfrom);
	my (%FROM_ADDR_LIST, $fromkey, $fromval, $result);
	
	$retval=0;
	${$Rretcntr}=0; ${$Rretmsgs}='';
	$mailfrom=$RCPSMTPD->{'FROM'};
	$hdrsfrom=$RCPHEADERS->{'From'};
	
	if ($mailfrom eq '<>') { $mailfrom='MAILER-DAEMON'; }
	print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): mailfrom=|$mailfrom| hdrsfrom=|$hdrsfrom|\n");
	
	$mailcleanfrom=$mailfrom;
	$hdrscleanfrom=$hdrsfrom;
	
	#$mailcleanfrom=~s/^[^<]*<//g;  $mailcleanfrom=~s/,[^<]*</,/g; # clean begin
	if (index($mailcleanfrom,'<')>=0) { $mailcleanfrom=substr($mailcleanfrom, index($mailcleanfrom,'<')+1); }
	$mailcleanfrom=~s/>[^<]*</,/g; $mailcleanfrom=~s/>[^<]* /,/g; # clean middle
	#$mailcleanfrom=~s/>[^<]*$//g; # clean end
	if (rindex($mailcleanfrom,'>')>=0) { $mailcleanfrom=substr($mailcleanfrom, 0, rindex($mailcleanfrom,'>')); }
	$mailcleanfrom=~s/ \([A-Za-z0-9 \-]*\)$//g; # clean login: user@domain (user) | user@domain (Sender Name)
	
	#$hdrscleanfrom=~s/^[^<]*<//g;  $hdrscleanfrom=~s/,[^<]*</,/g; # clean begin
	if (index($hdrscleanfrom,'<')>=0) { $hdrscleanfrom=substr($hdrscleanfrom, index($hdrscleanfrom,'<')+1) }
	$hdrscleanfrom=~s/>[^<]*</,/g; $hdrscleanfrom=~s/>[^<]* /,/g; # clean middle
	#$hdrscleanfrom=~s/>[^<]*$//g; # clean end
	if (rindex($hdrscleanfrom,'>')>=0) { $hdrscleanfrom=substr($hdrscleanfrom, 0, rindex($hdrscleanfrom,'>')); }
	#$hdrscleanfrom=~s/ \([A-Za-z0-9_ \-]*\)$//g; # clean login: user@domain (user) | user@domain (Sender Name)
	if (index($hdrscleanfrom,'(')>=0) { $hdrscleanfrom=substr($hdrscleanfrom, 0, index($hdrscleanfrom,'(')); $hdrscleanfrom=~s/[ ]*$//g; }
	
	$maildomainfrom=$mailcleanfrom;
	$hdrsdomainfrom=$hdrscleanfrom;
	if (index($maildomainfrom,'@')>0) { $maildomainfrom=substr($maildomainfrom,index($maildomainfrom,'@')+1); }
	if (index($hdrsdomainfrom,'@')>0) { $hdrsdomainfrom=substr($hdrsdomainfrom,index($hdrsdomainfrom,'@')+1); }
	
	print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): mailcleanfrom=|$mailcleanfrom| hdrscleanfrom=|$hdrscleanfrom|\n");
	print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): maildomainfrom=|$maildomainfrom| hdrsdomainfrom=|$hdrsdomainfrom|\n");
	
	
	
	#
	# MAIL FROM: MAILER-DAEMON
	# From: MAILER-DAEMON@domain
	#
	print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): |".substr($mailcleanfrom,0,length('MAILER-DAEMON'))."|eq|MAILER-DAEMON| && |".substr($hdrscleanfrom,0,length('MAILER-DAEMON'))."|eq|MAILER-DAEMON|\n");
	if (substr($mailcleanfrom,0,length('MAILER-DAEMON')) eq 'MAILER-DAEMON' && substr($hdrscleanfrom,0,length('MAILER-DAEMON')) eq 'MAILER-DAEMON') {
		# compare only beggining address, because:
		# MAIL FROM: <MAILER-DAEMON>
		# From: Mail System Name <MAILER-DAEMON@domain>
		$retval=1; ${$Rretcntr}=0; ${$Rretmsgs}='OK:MAILER-DAEMON';
		return $retval;
	}
	
	
	
	# compare stricte MAILFROM with From: from content
	# bad idea, because MAILFROM=root@domain sending email as From=logwatch@domain (and this rule catch that)
	#if ($mailcleanfrom ne $hdrscleanfrom) {
	#	${$Rretcntr}=${$Rretcntr}+10;
	#	${$Rretmsgs}=${$Rretmsgs}."(MAILFROM!=From) [".$RCPSMTPD->{'FROM'}."!=".$RCPHEADERS->{'From'}."] ";
	#}
	
	if (length($hdrsdomainfrom)>0) {
		# compare stricte domain:MAILFROM with domain:From: from content
		# it is not the best idea, because: MAILFROM=wysylka.example.org in From:example.org
		if (length($maildomainfrom)< length($hdrsdomainfrom)) {
			$hdrsdomainfrom=substr($hdrsdomainfrom, 0 - length($maildomainfrom));
			print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): maildomainfrom=|$maildomainfrom| hdrsdomainfrom=|$hdrsdomainfrom|\n");
			if ($maildomainfrom ne $hdrsdomainfrom) {
				${$Rretcntr}=${$Rretcntr}+$RCPCONFIG->{'from_mailfrom1diff2hdrsfrom_pkts'};
				${$Rretmsgs}=${$Rretmsgs}."(MAILFROM:domain!=From:domain) [$mailfrom($maildomainfrom)!=$hdrsfrom($hdrsdomainfrom)] ";
			}
		}
		if (length($maildomainfrom)> length($hdrsdomainfrom)) {
			$maildomainfrom=substr($maildomainfrom, 0 - length($hdrsdomainfrom));
			print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): maildomainfrom=|$maildomainfrom| hdrsdomainfrom=|$hdrsdomainfrom|\n");
			if ($maildomainfrom ne $hdrsdomainfrom) {
				${$Rretcntr}=${$Rretcntr}+$RCPCONFIG->{'from_mailfrom1diff2hdrsfrom_pkts'};
				${$Rretmsgs}=${$Rretmsgs}."(MAILFROM:domain!=From:domain) [$mailfrom($maildomainfrom)!=$hdrsfrom($hdrsdomainfrom)] ";
			}
		}
		if (length($maildomainfrom)==length($hdrsdomainfrom)) {
			if ($maildomainfrom ne $hdrsdomainfrom) {
				${$Rretcntr}=${$Rretcntr}+$RCPCONFIG->{'from_mailfrom1diff2hdrsfrom_pkts'};
				${$Rretmsgs}=${$Rretmsgs}."(MAILFROM:domain!=From:domain) [$mailfrom($maildomainfrom)!=$hdrsfrom($hdrsdomainfrom)] ";
			}
		}
	}
	
	if (index($RCPHEADERS->{'From'},',')>0) {
		${$Rretcntr}=${$Rretcntr}+$RCPCONFIG->{'from_multiplemailfrom_pkts'};
		${$Rretmsgs}=${$Rretmsgs}."(MULTIPLE From) [$hdrsfrom] ";
	}
	
	
	
	if (length($RCPHEADERS->{'From'})>0) {
		if (defined(${$RCPCONFIG}{'FROM_ADDR_LIST'})) {
			%FROM_ADDR_LIST=%{${$RCPCONFIG}{'FROM_ADDR_LIST'}};
			foreach $fromkey (sort(keys(%FROM_ADDR_LIST))) {
				$fromval=$FROM_ADDR_LIST{$fromkey};
				if (substr($fromval,0,1) eq '#') { next; }
				print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): fromkey=|$fromkey| fromval=|$fromval|\n");
				$result=index($RCPHEADERS->{'From'},$fromkey);
				if ($result>=0) {
					print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): MATCH: result=index($RCPHEADERS->{'From'},$fromkey): result=$result\n");
					if ($fromval eq 'OK' || $fromval eq 'NOK') {
						if ($fromval eq 'OK' ) { $retval=1; ${$Rretcntr}=0;                              ${$Rretmsgs}='OK:WHITE LISTED' ; }
						if ($fromval eq 'NOK') { $retval=1; ${$Rretcntr}=${$RCPCONFIG}{'spamcountpkts'}; ${$Rretmsgs}='NOK:BLACK LISTED'; }
						print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): MATCH: result=index($RCPHEADERS->{'From'},$fromkey): fromval=$fromval WHITE/BLACK LISTED retval=$retval\n");
						last;
					} else {
						${$Rretcntr}=${$Rretcntr}+$fromval; ${$Rretmsgs}=${$Rretmsgs}."match($RCPHEADERS->{'From'},$fromkey) ";
						print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): rowstatus=${$Rretcntr}:${$Rretmsgs}\n");
					}
				}
			}
		}
	}
	
	
	
	print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): status=".${$Rretcntr}.":".${$Rretmsgs}."\n");
	
	return $retval;
}



1; # return status for include mode


